rm(list=ls())
setwd('../Data/')

require(xts)
require(lubridate)
require(readxl)

raw <- list()# Ugh fuck tibbles and remove "date" column from all 
raw$p <- data.frame(read_excel('Vintages-PGDP.xlsx'))[,-1] 
raw$y <- data.frame(read_excel('Vintages-RGDP.xlsx'))[,-1] 
raw$u <- data.frame(read_excel('Vintages-unemployment-rate.xlsx'))[,-1]
raw$cu <- data.frame(read_excel('Vintages-cu-m.xlsx'))[,-1]

# First align CU vintages from monthly->quarterly
cuq <- xts(raw$cu[,seq(1, dim(raw$cu)[2],3)],
           order.by=seq(from=as.Date('1948-01-01'), to=as.Date('2022-06-01'), by='month'))
raw$cu.q <- apply.quarterly(cuq, mean)
index(raw$cu.q) <- as.yearqtr(index(raw$cu.q))
colnames(raw$cu.q) <- format(as.Date(seq(from=as.Date('1979-08-15'), by='quarter', length.out=dim(raw$cu.q)[2])),
                             format='%Y-%m-%d')

raw[['cu']] <- NULL
sapply(raw, dim) # Checking they're all the same size -- CU.Q is shorter!
V <- dim(raw$p)[2] # of vintages


# Create RT data, store vintages in list ------
vintages <- seq(from=as.Date('1965-11-15'), by='quarter', length.out=V)
rt.vintages <- list()
for (v in 1:V) {
  
  dates.all <- paste0('/', vintages[v] %m+% -months(3))
  dates.short <- paste0('1960/', vintages[v] %m+% -months(3))
  
  lgdp <- xts(100*log(raw$y[,v]), 
           order.by=as.yearqtr(seq(from=as.Date('1947-01-01'), to=as.Date('2022-01-01'), by='quarter')))[dates.all]
  pi <- xts(c(NA, 400*diff(log(raw$p[,v]))),
           order.by=as.yearqtr(seq(from=as.Date('1947-01-01'), to=as.Date('2022-01-01'), by='quarter')))[dates.all]
  u.m <- xts(raw$u[,v], order.by=seq(from=as.Date('1947-01-01'), to=as.Date('2022-04-01'), by='month')) # Watch out hard coded!
  u <- xts(aggregate(u.m, by=as.yearqtr(index(u.m)), mean))[dates.all]
  
  if (vintages[v] %in% as.Date(colnames(raw$cu.q))) {
    i <- which(as.Date(colnames(raw$cu.q)) == vintages[v])
    cu <- raw$cu.q[,i]
  } else {
    cu <- xts(order.by=as.yearqtr(seq(from=as.Date('1947-01-01'), to=as.Date('2022-04-01'), by='quarter')))[dates.all]
  }
  
  y <- merge(lgdp,pi,u,cu)[dates.short,]; colnames(y) <- c('lgdp', 'pi', 'u', 'cu')
  rt.vintages[[v]] <- list(vintage=vintages[v], lgdp=lgdp, pi=pi, u=u, cu=cu, y=y)
}


# Create QRT dataset in same format -------
qrt.vintages <- list()
for (v in 1:V) {
  
  dates.all <- paste0('/', vintages[v] %m+% -months(3))
  dates.short <- paste0('1960/', vintages[v] %m+% -months(3))
  
  lgdp <- xts(100*log(raw$y[,V]), 
              order.by=as.yearqtr(seq(from=as.Date('1947-01-01'), to=as.Date('2022-01-01'), by='quarter')))[dates.all]
  pi <- xts(c(NA, 400*diff(log(raw$p[,V]))),
            order.by=as.yearqtr(seq(from=as.Date('1947-01-01'), to=as.Date('2022-01-01'), by='quarter')))[dates.all]
  u.m <- xts(raw$u[,V], order.by=seq(from=as.Date('1947-01-01'), to=as.Date('2022-04-01'), by='month'))
  u <- xts(aggregate(u.m, by=as.yearqtr(index(u.m)), mean))[dates.all]
  cu <- raw$cu.q[,dim(raw$cu.q)[2]]
  
  y <- merge(lgdp,pi,u,cu)[dates.short,]; colnames(y) <- c('lgdp', 'pi', 'u', 'cu')
  
  qrt.vintages[[v]] <- list(vintage=vintages[v], lgdp=lgdp, pi=pi, u=u, cu=cu, y=y['1960/'])
  
}


# Save the output -------
save(rt.vintages, qrt.vintages, file='Vintage-datasets-Nov-2023.Rda')