clear

% Setup the Import Options and import the data
opts = delimitedTextImportOptions("NumVariables", 9);

% Specify range and delimiter
opts.DataLines = [2, Inf];
opts.Delimiter = "\t";

% Specify column names and types
opts.VariableNames = ["rtlgdp", "rtc", "qrtlgdp", "qrtc", "qflgdp", "qfc", "finallgdp", "finalc", "VarName9"];
opts.VariableTypes = ["string", "double", "double", "double", "double", "double", "double", "double", "double"];

% Specify file level properties
opts.ExtraColumnsRule = "ignore";
opts.EmptyLineRule = "read";

% Specify variable properties
opts = setvaropts(opts, "rtlgdp", "WhitespaceRule", "preserve");
opts = setvaropts(opts, "rtlgdp", "EmptyFieldRule", "auto");

% Import the data
tbl = readtable("\Decomposition\uc1_decomp.txt", opts);

% Convert to output type
dates_uc1 = tbl.rtlgdp;
rtlgdp_uc1 = tbl.rtc;
rtc_uc1 = tbl.qrtlgdp;
qrtlgdp_uc1 = tbl.qrtc;
qrtc_uc1 = tbl.qflgdp;
qflgdp_uc1 = tbl.qfc;
qfc_uc1 = tbl.finallgdp;
finallgdp_uc1 = tbl.finalc;
finalc_uc1 = tbl.VarName9;

% Clear temporary variables
clear opts tbl



% Setup the Import Options and import the data
opts = delimitedTextImportOptions("NumVariables", 13);

% Specify range and delimiter
opts.DataLines = [2, Inf];
opts.Delimiter = "\t";

% Specify column names and types
opts.VariableNames = ["rtlgdp", "rtcu", "rtc", "qrtlgdp", "qrtcu", "qrtc", "qflgdp", "qfcu", "qfc", "finallgdp", "finalcu", "finalc", "VarName13"];
opts.VariableTypes = ["string", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double"];

% Specify file level properties
opts.ExtraColumnsRule = "ignore";
opts.EmptyLineRule = "read";

% Specify variable properties
opts = setvaropts(opts, "rtlgdp", "WhitespaceRule", "preserve");
opts = setvaropts(opts, "rtlgdp", "EmptyFieldRule", "auto");

% Import the data
tbl = readtable("\Decomposition\uc2cu_decomp.txt", opts);

% Convert to output type
dates_uc2_cu = tbl.rtlgdp;
rtlgdp_uc2_cu = tbl.rtcu;
rtcu_uc2_cu = tbl.rtc;
rtc_uc2_cu = tbl.qrtlgdp;
qrtlgdp_uc2_cu = tbl.qrtcu;
qrtcu_uc2_cu = tbl.qrtc;
qrtc_uc2_cu = tbl.qflgdp;
qflgdp_uc2_cu = tbl.qfcu;
qfcu_uc2_cu = tbl.qfc;
qfc_uc2_cu = tbl.finallgdp;
finallgdp_uc2_cu = tbl.finalcu;
finalcu_uc2_cu = tbl.finalc;
finalc_uc2_cu = tbl.VarName13;

% Clear temporary variables
clear opts tbl


% Setup the Import Options and import the data
opts = delimitedTextImportOptions("NumVariables", 13);

% Specify range and delimiter
opts.DataLines = [2, Inf];
opts.Delimiter = "\t";

% Specify column names and types
opts.VariableNames = ["rtlgdp", "rtpi", "rtc", "qrtlgdp", "qrtpi", "qrtc", "qflgdp", "qfpi", "qfc", "finallgdp", "finalpi", "finalc", "VarName13"];
opts.VariableTypes = ["string", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double"];

% Specify file level properties
opts.ExtraColumnsRule = "ignore";
opts.EmptyLineRule = "read";

% Specify variable properties
opts = setvaropts(opts, "rtlgdp", "WhitespaceRule", "preserve");
opts = setvaropts(opts, "rtlgdp", "EmptyFieldRule", "auto");

% Import the data
tbl = readtable("\Decomposition\uc2pi_decomp.txt", opts);

% Convert to output type
dates_uc2_pi = tbl.rtlgdp;
rtlgdp_uc2_pi = tbl.rtpi;
rtpi_uc2_pi = tbl.rtc;
rtc_uc2_pi = tbl.qrtlgdp;
qrtlgdp_uc2_pi = tbl.qrtpi;
qrtpi_uc2_pi = tbl.qrtc;
qrtc_uc2_pi = tbl.qflgdp;
qflgdp_uc2_pi = tbl.qfpi;
qfpi_uc2_pi = tbl.qfc;
qfc_uc2_pi = tbl.finallgdp;
finallgdp_uc2_pi = tbl.finalpi;
finalpi_uc2_pi = tbl.finalc;
finalc_uc2_pi = tbl.VarName13;

% Clear temporary variables
clear opts tbl


% Setup the Import Options and import the data
opts = delimitedTextImportOptions("NumVariables", 13);

% Specify range and delimiter
opts.DataLines = [2, Inf];
opts.Delimiter = "\t";

% Specify column names and types
opts.VariableNames = ["rtlgdp", "rtu", "rtc", "qrtlgdp", "qrtu", "qrtc", "qflgdp", "qfu", "qfc", "finallgdp", "finalu", "finalc", "VarName13"];
opts.VariableTypes = ["string", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double"];

% Specify file level properties
opts.ExtraColumnsRule = "ignore";
opts.EmptyLineRule = "read";

% Specify variable properties
opts = setvaropts(opts, "rtlgdp", "WhitespaceRule", "preserve");
opts = setvaropts(opts, "rtlgdp", "EmptyFieldRule", "auto");

% Import the data
tbl = readtable("\Decomposition\uc2u_decomp.txt", opts);

% Convert to output type
dates_uc2 = tbl.rtlgdp;
rtlgdp_uc2 = tbl.rtu;
rtu_uc2 = tbl.rtc;
rtc_uc2 = tbl.qrtlgdp;
qrtlgdp_uc2 = tbl.qrtu;
qrtu_uc2 = tbl.qrtc;
qrtc_uc2 = tbl.qflgdp;
qflgdp_uc2 = tbl.qfu;
qfu_uc2 = tbl.qfc;
qfc_uc2 = tbl.finallgdp;
finallgdp_uc2 = tbl.finalu;
finalu_uc2 = tbl.finalc;
finalc_uc2 = tbl.VarName13;


% Clear temporary variables
clear opts tbl

% Setup the Import Options and import the data
opts = delimitedTextImportOptions("NumVariables", 17);

% Specify range and delimiter
opts.DataLines = [2, Inf];
opts.Delimiter = "\t";

% Specify column names and types
opts.VariableNames = ["rtlgdp", "rtu", "rtpi", "rtc", "qrtlgdp", "qrtu", "qrtpi", "qrtc", "qflgdp", "qfu", "qfpi", "qfc", "finallgdp", "finalu", "finalpi", "finalc", "VarName17"];
opts.VariableTypes = ["string", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double", "double"];

% Specify file level properties
opts.ExtraColumnsRule = "ignore";
opts.EmptyLineRule = "read";

% Specify variable properties
opts = setvaropts(opts, "rtlgdp", "WhitespaceRule", "preserve");
opts = setvaropts(opts, "rtlgdp", "EmptyFieldRule", "auto");

% Import the data
tbl = readtable("\Decomposition\uc3_decomp.txt", opts);

% Convert to output type
dates_uc3 = tbl.rtlgdp;
rtlgdp_uc3 = tbl.rtu;
rtu_uc3 = tbl.rtpi;
rtpi_uc3 = tbl.rtc;
rtc_uc3 = tbl.qrtlgdp;
qrtlgdp_uc3 = tbl.qrtu;
qrtu_uc3 = tbl.qrtpi;
qrtpi_uc3 = tbl.qrtc;
qrtc_uc3 = tbl.qflgdp;
qflgdp_uc3 = tbl.qfu;
qfu_uc3 = tbl.qfpi;
qfpi_uc3 = tbl.qfc;
qfc_uc3 = tbl.finallgdp;
finallgdp_uc3 = tbl.finalu;
finalu_uc3 = tbl.finalpi;
finalpi_uc3 = tbl.finalc;
finalc_uc3 = tbl.VarName17;

% Clear temporary variables
clear opts tbl

% Setup the Import Options and import the data
opts = delimitedTextImportOptions("NumVariables", 9);

% Specify range and delimiter
opts.DataLines = [2, Inf];
opts.Delimiter = "\t";

% Specify column names and types
opts.VariableNames = ["rtlgdp", "rtc", "qrtlgdp", "qrtc", "qflgdp", "qfc", "finallgdp", "finalc", "VarName9"];
opts.VariableTypes = ["string", "double", "double", "double", "double", "double", "double", "double", "double"];

% Specify file level properties
opts.ExtraColumnsRule = "ignore";
opts.EmptyLineRule = "read";

% Specify variable properties
opts = setvaropts(opts, "rtlgdp", "WhitespaceRule", "preserve");
opts = setvaropts(opts, "rtlgdp", "EmptyFieldRule", "auto");

% Import the data
tbl = readtable("\Decomposition\hp_ss_decomp.txt", opts);

% Convert to output type
dates_hp = tbl.rtlgdp;
rtlgdp_hp = tbl.rtc;
rtc_hp = tbl.qrtlgdp;
qrtlgdp_hp = tbl.qrtc;
qrtc_hp = tbl.qflgdp;
qflgdp_hp = tbl.qfc;
qfc_hp = tbl.finallgdp;
finallgdp_hp = tbl.finalc;
finalc_hp = tbl.VarName9;

dates_hp_gar = tbl.rtlgdp;
rtlgdp_hp_gar = tbl.rtc;
rtc_hp_gar = tbl.qrtlgdp;
qrtlgdp_hp_gar = tbl.qrtc;
qrtc_hp_gar = tbl.qflgdp;
qflgdp_hp_gar = tbl.qfc;
qfc_hp_gar = tbl.finallgdp;
finallgdp_hp_gar = tbl.finalc;
finalc_hp_gar = tbl.VarName9;


% Clear temporary variables
clear opts tbl

save decomp_contributions

clear

load decomp_contributions

check_revisions = 0;    % equal to one if you want to check decompositions sum up to totals
charts_production = 0;  % equal to one if you want to plot charts
real_time_du = 0;       % equal to one if you want to plot revisions from real time to final
quasi_final_du = 0;     % equal to one if you want to plot revisions from quasi_final to final
NSR_results = 0;
variances_results = 1;
std_results = 0;
covariances_show = 1;

%x_plot = [1:length(finalc_uc2)]';
x_plot = datetime(1980,1,1) + calquarters(0:155);

%%% Compute revisions

% UC1
    % RT to final
    revision_f_rt_uc1 = finalc_uc1-rtc_uc1;
    revision_f_rt_gdp_uc1 = finallgdp_uc1-rtlgdp_uc1;
    % Real-time to quasi-real-time
    revision_qrt_rt_uc1 = qrtc_uc1-rtc_uc1;
    revision_qrt_rt_gdp_uc1 = qrtlgdp_uc1-rtlgdp_uc1;
    % Quasi-real-time to quasi-final
    revision_qf_qrt_uc1 = qfc_uc1-qrtc_uc1;
    revision_qf_qrt_gdp_uc1 = qflgdp_uc1-qrtlgdp_uc1;
    % Quasi-final to final
    revision_f_qf_uc1 = finalc_uc1-qfc_uc1;
    revision_f_qf_gdp_uc1 = finallgdp_uc1-qflgdp_uc1;
% HP
    % RT to final
    revision_f_rt_hp = finalc_hp-rtc_hp;
    revision_f_rt_gdp_hp = finallgdp_hp-rtlgdp_hp;
    % Real-time to quasi-real-time
    revision_qrt_rt_hp = qrtc_hp-rtc_hp;
    revision_qrt_rt_gdp_hp = qrtlgdp_hp-rtlgdp_hp;
    % Quasi-real-time to quasi-final
    revision_qf_qrt_hp = qfc_hp-qrtc_hp;
    revision_qf_qrt_gdp_hp = qflgdp_hp-qrtlgdp_hp;
    % Quasi-final to final
    revision_f_qf_hp = finalc_hp-qfc_hp;
    revision_f_qf_gdp_hp = finallgdp_hp-qflgdp_hp;
% HP Garratt
    % RT to final
    revision_f_rt_hp_gar = finalc_hp_gar-rtc_hp_gar;
    revision_f_rt_gdp_hp_gar = finallgdp_hp_gar-rtlgdp_hp_gar;
    % Real-time to quasi-real-time
    revision_qrt_rt_hp_gar = qrtc_hp_gar-rtc_hp_gar;
    revision_qrt_rt_gdp_hp_gar = qrtlgdp_hp_gar-rtlgdp_hp_gar;
    % Quasi-real-time to quasi-final
    revision_qf_qrt_hp_gar = qfc_hp_gar-qrtc_hp_gar;
    revision_qf_qrt_gdp_hp_gar = qflgdp_hp_gar-qrtlgdp_hp_gar;
    % Quasi-final to final
    revision_f_qf_hp_gar = finalc_hp_gar-qfc_hp_gar;
    revision_f_qf_gdp_hp_gar = finallgdp_hp_gar-qflgdp_hp_gar;
% UC2 - Unemployment
    % RT to final
    revision_f_rt_uc2 = finalc_uc2-rtc_uc2;
    revision_f_rt_gdp_uc2 = finallgdp_uc2-rtlgdp_uc2;
    revision_f_rt_u_uc2 = finalu_uc2-rtu_uc2;
    % Real-time to quasi-real-time
    revision_qrt_rt_uc2 = qrtc_uc2-rtc_uc2;
    revision_qrt_rt_gdp_uc2 = qrtlgdp_uc2-rtlgdp_uc2;
    revision_qrt_rt_u_uc2 = qrtu_uc2-rtu_uc2;
    % Quasi-real-time to quasi-final
    revision_qf_qrt_uc2 = qfc_uc2-qrtc_uc2;
    revision_qf_qrt_gdp_uc2 = qflgdp_uc2-qrtlgdp_uc2;
    revision_qf_qrt_u_uc2 = qfu_uc2-qrtu_uc2;
    % Quasi-final to final
    revision_f_qf_uc2 = finalc_uc2-qfc_uc2;
    revision_f_qf_gdp_uc2 = finallgdp_uc2-qflgdp_uc2;
    revision_f_qf_u_uc2 = finalu_uc2-qfu_uc2;
% UC2 - Inflation
    % RT to final
    revision_f_rt_uc2_pi = finalc_uc2_pi-rtc_uc2_pi;
    revision_f_rt_gdp_uc2_pi = finallgdp_uc2_pi-rtlgdp_uc2_pi;
    revision_f_rt_pi_uc2_pi = finalpi_uc2_pi-rtpi_uc2_pi;
    % Real-time to quasi-real-time
    revision_qrt_rt_uc2_pi = qrtc_uc2_pi-rtc_uc2_pi;
    revision_qrt_rt_gdp_uc2_pi = qrtlgdp_uc2_pi-rtlgdp_uc2_pi;
    revision_qrt_rt_pi_uc2_pi = qrtpi_uc2_pi-rtpi_uc2_pi;
    % Quasi-real-time to quasi-final
    revision_qf_qrt_uc2_pi = qfc_uc2_pi-qrtc_uc2_pi;
    revision_qf_qrt_gdp_uc2_pi = qflgdp_uc2_pi-qrtlgdp_uc2_pi;
    revision_qf_qrt_pi_uc2_pi = qfpi_uc2_pi-qrtpi_uc2_pi;
    % Quasi-final to final
    revision_f_qf_uc2_pi = finalc_uc2_pi-qfc_uc2_pi;
    revision_f_qf_gdp_uc2_pi = finallgdp_uc2_pi-qflgdp_uc2_pi;
    revision_f_qf_pi_uc2_pi = finalpi_uc2_pi-qfpi_uc2_pi;
% UC2 - Capacity utilization
    index_nonmissing = ~isnan(rtc_uc2_cu);
    % RT to final
    revision_f_rt_uc2_cu = finalc_uc2_cu(index_nonmissing)-rtc_uc2_cu(index_nonmissing);
    revision_f_rt_gdp_uc2_cu = finallgdp_uc2_cu(index_nonmissing)-rtlgdp_uc2_cu(index_nonmissing);
    revision_f_rt_cu_uc2_cu = finalcu_uc2_cu(index_nonmissing)-rtcu_uc2_cu(index_nonmissing);
    % Real-time to quasi-real-time
    revision_qrt_rt_uc2_cu = qrtc_uc2_cu(index_nonmissing)-rtc_uc2_cu(index_nonmissing);
    revision_qrt_rt_gdp_uc2_cu = qrtlgdp_uc2_cu(index_nonmissing)-rtlgdp_uc2_cu(index_nonmissing);
    revision_qrt_rt_cu_uc2_cu = qrtcu_uc2_cu(index_nonmissing)-rtcu_uc2_cu(index_nonmissing);
    % Quasi-real-time to quasi-final
    revision_qf_qrt_uc2_cu = qfc_uc2_cu(index_nonmissing)-qrtc_uc2_cu(index_nonmissing);
    revision_qf_qrt_gdp_uc2_cu = qflgdp_uc2_cu(index_nonmissing)-qrtlgdp_uc2_cu(index_nonmissing);
    revision_qf_qrt_cu_uc2_cu = qfcu_uc2_cu(index_nonmissing)-qrtcu_uc2_cu(index_nonmissing);
    % Quasi-final to final
    revision_f_qf_uc2_cu = finalc_uc2_cu(index_nonmissing)-qfc_uc2_cu(index_nonmissing);
    revision_f_qf_gdp_uc2_cu = finallgdp_uc2_cu(index_nonmissing)-qflgdp_uc2_cu(index_nonmissing);
    revision_f_qf_cu_uc2_cu = finalcu_uc2_cu(index_nonmissing)-qfcu_uc2_cu(index_nonmissing);
% UC3
    % RT to final
    revision_f_rt_uc3 = finalc_uc3-rtc_uc3;
    revision_f_rt_gdp_uc3 = finallgdp_uc3-rtlgdp_uc3;
    revision_f_rt_u_uc3 = finalu_uc3-rtu_uc3;
    revision_f_rt_pi_uc3 = finalpi_uc3-rtpi_uc3;
    % Real-time to quasi-real-time
    revision_qrt_rt_uc3 = qrtc_uc3-rtc_uc3;
    revision_qrt_rt_gdp_uc3 = qrtlgdp_uc3-rtlgdp_uc3;
    revision_qrt_rt_u_uc3 = qrtu_uc3-rtu_uc3;
    revision_qrt_rt_pi_uc3 = qrtpi_uc3-rtpi_uc3;
    % Quasi-real-time to quasi-final
    revision_qf_qrt_uc3 = qfc_uc3-qrtc_uc3;
    revision_qf_qrt_gdp_uc3 = qflgdp_uc3-qrtlgdp_uc3;
    revision_qf_qrt_u_uc3 = qfu_uc3-qrtu_uc3;
    revision_qf_qrt_pi_uc3 = qfpi_uc3-qrtpi_uc3;
    % Quasi-final to final
    revision_f_qf_uc3 = finalc_uc3-qfc_uc3;
    revision_f_qf_gdp_uc3 = finallgdp_uc3-qflgdp_uc3;
    revision_f_qf_u_uc3 = finalu_uc3-qfu_uc3;
    revision_f_qf_pi_uc3 = finalpi_uc3-qfpi_uc3;    
    
    
if check_revisions==1
    % Check that the contributions sum up to total
% UC1
    check_revision_uc1 = revision_f_rt_uc1-revision_f_rt_gdp_uc1;
    max(check_revision_uc1)
    min(check_revision_uc1)
    median(check_revision_uc1)
    check_revision_uc1 = revision_f_qf_uc1-revision_f_qf_gdp_uc1 ;
    max(check_revision_uc1)
    min(check_revision_uc1)
    median(check_revision_uc1)
    check_revision_uc1 = revision_qf_qrt_uc1-revision_qf_qrt_gdp_uc1 ;
    max(check_revision_uc1)
    min(check_revision_uc1)
    median(check_revision_uc1)
    check_revision_uc1 = revision_qrt_rt_uc1-revision_qrt_rt_gdp_uc1 ;
    max(check_revision_uc1)
    min(check_revision_uc1)
    median(check_revision_uc1)
    check_revision_uc1 = revision_f_rt_uc1-revision_f_qf_uc1 - revision_qf_qrt_uc1-revision_qrt_rt_uc1;
    max(check_revision_uc1)
    min(check_revision_uc1)
    median(check_revision_uc1)        
% HP
    check_revision_hp = revision_f_rt_hp-revision_f_rt_gdp_hp;
    max(check_revision_hp)
    min(check_revision_hp)
    median(check_revision_hp)
    check_revision_hp = revision_f_qf_hp-revision_f_qf_gdp_hp ;
    max(check_revision_hp)
    min(check_revision_hp)
    median(check_revision_hp)
    check_revision_hp = revision_qf_qrt_hp-revision_qf_qrt_gdp_hp ;
    max(check_revision_hp)
    min(check_revision_hp)
    median(check_revision_hp)
    check_revision_hp = revision_qrt_rt_hp-revision_qrt_rt_gdp_hp ;
    max(check_revision_hp)
    min(check_revision_hp)
    median(check_revision_hp)
    check_revision_hp = revision_f_rt_hp-revision_f_qf_hp - revision_qf_qrt_hp-revision_qrt_rt_hp;
    max(check_revision_hp)
    min(check_revision_hp)
    median(check_revision_hp)        
% HP Garratt
    check_revision_hp_gar = revision_f_rt_hp_gar-revision_f_rt_gdp_hp_gar;
    max(check_revision_hp_gar)
    min(check_revision_hp_gar)
    median(check_revision_hp_gar)
    check_revision_hp_gar = revision_f_qf_hp_gar-revision_f_qf_gdp_hp_gar ;
    max(check_revision_hp_gar)
    min(check_revision_hp_gar)
    median(check_revision_hp_gar)
    check_revision_hp_gar = revision_qf_qrt_hp_gar-revision_qf_qrt_gdp_hp_gar ;
    max(check_revision_hp_gar)
    min(check_revision_hp_gar)
    median(check_revision_hp_gar)
    check_revision_hp_gar = revision_qrt_rt_hp_gar-revision_qrt_rt_gdp_hp_gar ;
    max(check_revision_hp_gar)
    min(check_revision_hp_gar)
    median(check_revision_hp_gar)
    check_revision_hp_gar = revision_f_rt_hp_gar-revision_f_qf_hp_gar - revision_qf_qrt_hp_gar-revision_qrt_rt_hp_gar;
    max(check_revision_hp_gar)
    min(check_revision_hp_gar)
    median(check_revision_hp_gar)        
% UC2 - Unemployment
    check_final_uc2 = finalc_uc2-finallgdp_uc2 - finalu_uc2;
    max(check_final_uc2)
    min(check_final_uc2)
    median(check_final_uc2)
    check_revision_uc2 = revision_f_rt_uc2-revision_f_rt_gdp_uc2 - revision_f_rt_u_uc2;
    max(check_revision_uc2)
    min(check_revision_uc2)
    median(check_revision_uc2)
    check_revision_uc2 = revision_f_qf_uc2-revision_f_qf_gdp_uc2 - revision_f_qf_u_uc2;
    max(check_revision_uc2)
    min(check_revision_uc2)
    median(check_revision_uc2)
    check_revision_uc2 = revision_qf_qrt_uc2-revision_qf_qrt_gdp_uc2 - revision_qf_qrt_u_uc2;
    max(check_revision_uc2)
    min(check_revision_uc2)
    median(check_revision_uc2)
    check_revision_uc2 = revision_qrt_rt_uc2-revision_qrt_rt_gdp_uc2 - revision_qrt_rt_u_uc2;
    max(check_revision_uc2)
    min(check_revision_uc2)
    median(check_revision_uc2)
    check_revision_uc2 = revision_f_rt_uc2-revision_f_qf_uc2 - revision_qf_qrt_uc2-revision_qrt_rt_uc2;
    max(check_revision_uc2)
    min(check_revision_uc2)
    median(check_revision_uc2)
% UC2 - Inflation
    check_final_uc2_pi = finalc_uc2_pi-finallgdp_uc2_pi - finalpi_uc2_pi;
    max(check_final_uc2_pi)
    min(check_final_uc2_pi)
    median(check_final_uc2_pi)
    check_revision_uc2_pi = revision_f_rt_uc2_pi-revision_f_rt_gdp_uc2_pi - revision_f_rt_pi_uc2_pi;
    max(check_revision_uc2_pi)
    min(check_revision_uc2_pi)
    median(check_revision_uc2_pi)
    check_revision_uc2_pi = revision_qrt_rt_uc2_pi-revision_qrt_rt_gdp_uc2_pi - revision_qrt_rt_pi_uc2_pi;
    max(check_revision_uc2_pi)
    min(check_revision_uc2_pi)
    median(check_revision_uc2_pi)
    check_revision_uc2_pi = revision_qf_qrt_uc2_pi-revision_qf_qrt_gdp_uc2_pi - revision_qf_qrt_pi_uc2_pi;
    max(check_revision_uc2_pi)
    min(check_revision_uc2_pi)
    median(check_revision_uc2_pi)
    check_revision_uc2_pi = revision_f_qf_uc2_pi-revision_f_qf_gdp_uc2_pi - revision_f_qf_pi_uc2_pi;
    max(check_revision_uc2_pi)
    min(check_revision_uc2_pi)
    median(check_revision_uc2_pi)
    check_revision_uc2 = revision_f_rt_uc2_pi-revision_qrt_rt_uc2_pi - revision_qf_qrt_uc2_pi-revision_f_qf_uc2_pi;
    max(check_revision_uc2)
    min(check_revision_uc2)
    median(check_revision_uc2)
% UC2 - Capacity utilization
    check_final_uc2_cu = finalc_uc2_cu-finallgdp_uc2_cu - finalcu_uc2_cu;
    max(check_final_uc2_cu)
    min(check_final_uc2_cu)
    median(check_final_uc2_cu)
    check_revision_uc2_cu = revision_f_rt_uc2_cu-revision_f_rt_gdp_uc2_cu - revision_f_rt_cu_uc2_cu;
    max(check_revision_uc2_cu)
    min(check_revision_uc2_cu)
    median(check_revision_uc2_cu)
    check_revision_uc2_cu = revision_qrt_rt_uc2_cu-revision_qrt_rt_gdp_uc2_cu - revision_qrt_rt_cu_uc2_cu;
    max(check_revision_uc2_cu)
    min(check_revision_uc2_cu)
    median(check_revision_uc2_cu)
    check_revision_uc2_cu = revision_qf_qrt_uc2_cu-revision_qf_qrt_gdp_uc2_cu - revision_qf_qrt_cu_uc2_cu;
    max(check_revision_uc2_cu)
    min(check_revision_uc2_cu)
    median(check_revision_uc2_cu)
    check_revision_uc2_cu = revision_f_qf_uc2_cu-revision_f_qf_gdp_uc2_cu - revision_f_qf_cu_uc2_cu;
    max(check_revision_uc2_cu)
    min(check_revision_uc2_cu)
    median(check_revision_uc2_cu)
    check_revision_uc2 = revision_f_rt_uc2_cu-revision_qrt_rt_uc2_cu - revision_qf_qrt_uc2_cu-revision_f_qf_uc2_cu;
    max(check_revision_uc2)
    min(check_revision_uc2)
    median(check_revision_uc2)   
% UC3
    check_final_uc3 = finalc_uc3-finallgdp_uc3 - finalu_uc3-finalpi_uc3;
    max(check_final_uc3)
    min(check_final_uc3)
    median(check_final_uc3)
    check_revision_uc3 = revision_f_rt_uc3-revision_f_rt_gdp_uc3 - revision_f_rt_u_uc3-revision_f_rt_pi_uc3;
    max(check_revision_uc3)
    min(check_revision_uc3)
    median(check_revision_uc3)
    check_revision_uc3 = revision_f_qf_uc3-revision_f_qf_gdp_uc3 - revision_f_qf_u_uc3-revision_f_qf_pi_uc3;
    max(check_revision_uc3)
    min(check_revision_uc3)
    median(check_revision_uc3)
    check_revision_uc3 = revision_qf_qrt_uc3-revision_qf_qrt_gdp_uc3 - revision_qf_qrt_u_uc3-revision_qf_qrt_pi_uc3;
    max(check_revision_uc3)
    min(check_revision_uc3)
    median(check_revision_uc3)
    check_revision_uc3 = revision_qrt_rt_uc3-revision_qrt_rt_gdp_uc3 - revision_qrt_rt_u_uc3-revision_qrt_rt_pi_uc3;
    max(check_revision_uc3)
    min(check_revision_uc3)
    median(check_revision_uc3)
    check_revision_uc3 = revision_f_rt_uc3-revision_f_qf_uc3 - revision_qf_qrt_uc3-revision_qrt_rt_uc3;
    max(check_revision_uc3)
    min(check_revision_uc3)
    median(check_revision_uc3)
end

 
if variances_results == 1

disp('   ')
disp('   ')
disp('Variances')
disp('   ')
disp('   ')



disp('   ')
disp('   ')
disp('HP   ')
disp('   ') 
disp(['Noise-to-signal ratio - HP(GDP):                                   ',num2str(std(revision_f_rt_hp)/std(finalc_hp),4)])
disp(['Variance of final estimate of output gap - HP(GDP):                ',num2str(var(finalc_hp),4)])
disp(['Variance of revision RT to F - HP(GDP):                            ',num2str(var(revision_f_rt_hp),4)])
disp('   ')

disp(['  End-point - Variance of revision QF to F - HP(GDP):                    ',num2str(var(revision_f_qf_hp),4)])
disp(['  Param. Inst. - Variance of revision QRT to QF - HP(GDP):               ',num2str(var(revision_qf_qrt_hp),4)])
disp(['  Data Revision - Variance of revision RT to QRT - HP(GDP):              ',num2str(var(revision_qrt_rt_hp),4)])
disp(['  Residual - HP(GDP):                                                    ',num2str((var(revision_f_rt_hp)-var(revision_f_qf_hp)-var(revision_qf_qrt_hp)-var(revision_qrt_rt_hp)),4)])


disp('   ')
disp(['Rel Variance of revision RT to F - HP(GDP):                        ',num2str((var(revision_f_rt_hp)/var(finalc_hp)),4)])
disp(['  Rel End-point - Variance of revision QF to F - HP(GDP):                    ',num2str(var(revision_f_qf_hp)/var(finalc_hp),4)])
disp(['  Rel Param. Inst. - Variance of revision QRT to QF - HP(GDP):               ',num2str(var(revision_qf_qrt_hp)/var(finalc_hp),4)])
disp(['  Rel Data Revision - Rel Variance of revision RT to QRT - HP(GDP):              ',num2str(var(revision_qrt_rt_hp)/var(finalc_hp),4)])
disp(['  Rel Residual - HP(GDP):                                                    ',num2str((var(revision_f_rt_hp)-var(revision_f_qf_hp)-var(revision_qf_qrt_hp)-var(revision_qrt_rt_hp))/var(finalc_hp),4)])
disp('   ')


disp('   ')
disp('   ')
disp('UC1   ')
disp('   ')
disp(['Noise-to-signal ratio - UC1(GDP):                                   ',num2str(std(revision_f_rt_uc1)/std(finalc_uc1),4)])
disp(['Variance of final estimate of output gap - UC1(GDP):                ',num2str(var(finalc_uc1),4)])
disp(['Variance of revision RT to F - UC1(GDP):                            ',num2str(var(revision_f_rt_uc1),4)])

disp('   ')
disp(['  End-point - Variance of revision QF to F - UC1(GDP):                    ',num2str(var(revision_f_qf_uc1),4)])
disp(['  Param. Inst. - Variance of revision QRT to QF - UC1(GDP):               ',num2str(var(revision_qf_qrt_uc1),4)])
disp(['  Data Revision - Variance of revision RT to QRT - UC1(GDP):              ',num2str(var(revision_qrt_rt_uc1),4)])
disp(['  Residual - UC1(GDP):                                                    ',num2str((var(revision_f_rt_uc1)-var(revision_f_qf_uc1)-var(revision_qf_qrt_uc1)-var(revision_qrt_rt_uc1)),4)])
disp('   ')


disp(['Rel Variance of revision RT to F - UC1(GDP):                            ',num2str(var(revision_f_rt_uc1)/var(finalc_uc1),4)])
disp(['  Rel End-point - Variance of revision QF to F - UC1(GDP):                    ',num2str(var(revision_f_qf_uc1)/var(finalc_uc1),4)])
disp(['  Rel Param. Inst. - Variance of revision QRT to QF - UC1(GDP):               ',num2str(var(revision_qf_qrt_uc1)/var(finalc_uc1),4)])
disp(['  Rel Data Revision - Variance of revision RT to QRT - UC1(GDP):              ',num2str(var(revision_qrt_rt_uc1)/var(finalc_uc1),4)])
disp(['  Rel Residual - UC1(GDP):                                                    ',num2str((var(revision_f_rt_uc1)-var(revision_f_qf_uc1)-var(revision_qf_qrt_uc1)-var(revision_qrt_rt_uc1))/var(finalc_uc1),4)])
disp('   ')



disp('   ')
disp('UC2 - Unemployment   ')
disp('   ')
disp(['Noise-to-signal ratio - UC2(GDP,u):                                 ',num2str(std(revision_f_rt_uc2)/std(finalc_uc2),4)])
disp(['Variance of final estimate of output gap - UC2(GDP,u):              ',num2str(var(finalc_uc2),4)])
disp(['Variance of revision RT to F - UC2(GDP,u):                          ',num2str(var(revision_f_rt_uc2),4)])
disp(' ')
disp(['  Variance of revision RT to F - GDP  - UC2(GDP,u):                       ',num2str(var(revision_f_rt_gdp_uc2),4)])
disp(['  Variance of revision RT to F - u  - UC2(GDP,u):                         ',num2str(var(revision_f_rt_u_uc2),4)])
disp(['  Variance of revision RT to F - residual UC2(GDP,u):                     ',num2str((var(revision_f_rt_uc2)-var(revision_f_rt_gdp_uc2)-var(revision_f_rt_u_uc2)),4)])
disp('   ')

disp(['  End-point - Variance of revision QF to F - UC2(GDP,u):                  ',num2str(var(revision_f_qf_uc2),4)])
disp(['     End-point - Variance of revision QF to F - GDP - UC2(GDP,u):            ',num2str(var(revision_f_qf_gdp_uc2),4)])
disp(['     End-point - Variance of revision QF to F - u - UC2(GDP,u):              ',num2str(var(revision_f_qf_u_uc2),4)])
disp(['  Param. Inst. - Variance of revision QRT to QF - UC2(GDP,u):             ',num2str(var(revision_qf_qrt_uc2),4)])
disp(['     Param. Inst. - Variance of revision QRT to QF - GDP - UC2(GDP,u):       ',num2str(var(revision_qf_qrt_gdp_uc2),4)])
disp(['     Param. Inst. - Variance of revision QRT to QF - u - UC2(GDP,u):         ',num2str(var(revision_qf_qrt_u_uc2),4)])
disp(['  Data Revision - Variance of revision RT to QRT - UC2(GDP,u):            ',num2str(var(revision_qrt_rt_uc2),4)])
disp(['     Data Revision - Variance of revision RT to QRT - GDP - UC2(GDP,u):      ',num2str(var(revision_qrt_rt_gdp_uc2),4)])
disp(['     Data Revision - Variance of revision RT to QRT - u - UC2(GDP,u):        ',num2str(var(revision_qrt_rt_u_uc2),4)])
disp(['  Residual - UC2(GDP,u):                                                  ',num2str((var(revision_f_rt_uc2)-var(revision_f_qf_uc2)-var(revision_qf_qrt_uc2)-var(revision_qrt_rt_uc2)),4)])
disp('   ')

disp(['Rel Variance of revision RT to F - UC2(GDP,u):                          ',num2str(var(revision_f_rt_uc2)/var(finalc_uc2),4)])
disp(['  Rel End-point - Variance of revision QF to F - UC2(GDP,u):                  ',num2str(var(revision_f_qf_uc2)/var(finalc_uc2),4)])
disp(['     Rel End-point - Variance of revision QF to F - GDP - UC2(GDP,u):            ',num2str(var(revision_f_qf_gdp_uc2)/var(finalc_uc2),4)])
disp(['     Rel End-point - Variance of revision QF to F - u - UC2(GDP,u):              ',num2str(var(revision_f_qf_u_uc2)/var(finalc_uc2),4)])
disp(['  Rel Param. Inst. - Variance of revision QRT to QF - UC2(GDP,u):             ',num2str(var(revision_qf_qrt_uc2)/var(finalc_uc2),4)])
disp(['     Rel Param. Inst. - Variance of revision QRT to QF - GDP - UC2(GDP,u):       ',num2str(var(revision_qf_qrt_gdp_uc2)/var(finalc_uc2),4)])
disp(['     Rel Param. Inst. - Variance of revision QRT to QF - u - UC2(GDP,u):         ',num2str(var(revision_qf_qrt_u_uc2)/var(finalc_uc2),4)])
disp(['  Rel Data Revision - Variance of revision RT to QRT - UC2(GDP,u):            ',num2str(var(revision_qrt_rt_uc2)/var(finalc_uc2),4)])
disp(['     Rel Data Revision - Variance of revision RT to QRT - GDP - UC2(GDP,u):      ',num2str(var(revision_qrt_rt_gdp_uc2)/var(finalc_uc2),4)])
disp(['     Rel Data Revision - Variance of revision RT to QRT - u - UC2(GDP,u):        ',num2str(var(revision_qrt_rt_u_uc2)/var(finalc_uc2),4)])
disp(['  Rel Residual - UC2(GDP,u):                                                  ',num2str((var(revision_f_rt_uc2)-var(revision_f_qf_uc2)-var(revision_qf_qrt_uc2)-var(revision_qrt_rt_uc2)/var(finalc_uc2)),4)])
disp('   ')




disp('   ')
disp('UC3   ')
disp('   ')
disp(['Noise-to-signal ratio - UC3:                                        ',num2str(std(revision_f_rt_uc3)/std(finalc_uc3),4)])
disp(['Variance of final estimate of output gap - UC3:                     ',num2str(var(finalc_uc3),4)])
disp(['Variance of revision RT to F - UC3:                                 ',num2str(var(revision_f_rt_uc3),4)])
disp(['Variance of revision RT to F - GDP  - UC3:                                ',num2str(var(revision_f_rt_gdp_uc3),4)])
disp(['Variance of revision RT to F - u  - UC3:                                  ',num2str(var(revision_f_rt_u_uc3),4)])
disp(['Variance of revision RT to F - pi  - UC3:                                 ',num2str(var(revision_f_rt_pi_uc3),4)])
disp(['Variance of revision RT to F - residual  - UC3:                           ',num2str((var(revision_f_rt_uc3)-var(revision_f_rt_gdp_uc3)-var(revision_f_rt_u_uc3)-var(revision_f_rt_pi_uc3)),4)])

disp('   ')
disp(['  End-point - Variance of revision QF to F - UC3:                         ',num2str(var(revision_f_qf_uc3),4)])
disp(['     End-point - Variance of revision QF to F - GDP - UC3:                   ',num2str(var(revision_f_qf_gdp_uc3),4)])
disp(['     End-point - Variance of revision QF to F - u - UC3:                     ',num2str(var(revision_f_qf_u_uc3),4)])
disp(['     End-point - Variance of revision QF to F - pi - UC3:                    ',num2str(var(revision_f_qf_pi_uc3),4)])
disp(['  Param. Inst. - Variance of revision QRT to QF - UC3:                    ',num2str(var(revision_qf_qrt_uc3),4)])
disp(['     Param. Inst. - Variance of revision QRT to QF - GDP - UC3:              ',num2str(var(revision_qf_qrt_gdp_uc3),4)])
disp(['     Param. Inst. - Variance of revision QRT to QF - u - UC3:                ',num2str(var(revision_qf_qrt_u_uc3),4)])
disp(['     Param. Inst. - Variance of revision QRT to QF - pi - UC3:               ',num2str(var(revision_qf_qrt_pi_uc3),4)])
disp(['  Data Revision - Variance of revision RT to QRT - UC3:                   ',num2str(var(revision_qrt_rt_uc3),4)])
disp(['     Data Revision - Variance of revision RT to QRT - GDP - UC3:             ',num2str(var(revision_qrt_rt_gdp_uc3),4)])
disp(['     Data Revision - Variance of revision RT to QRT - u - UC3:               ',num2str(var(revision_qrt_rt_u_uc3),4)])
disp(['     Data Revision - Variance of revision RT to QRT - pi - UC3:              ',num2str(var(revision_qrt_rt_pi_uc3),4)])
disp(['  Residual - UC3:                                                         ',num2str((var(revision_f_rt_uc3)-var(revision_f_qf_uc3)-var(revision_qf_qrt_uc3)-var(revision_qrt_rt_uc3)),4)])
disp('   ')

disp('   ')
disp(['Rel Variance of revision RT to F - UC3:                                 ',num2str(var(revision_f_rt_uc3)/var(finalc_uc3),4)])
disp(['  Rel End-point - Variance of revision QF to F - UC3:                         ',num2str(var(revision_f_qf_uc3)/var(finalc_uc3),4)])
disp(['     Rel End-point - Variance of revision QF to F - GDP - UC3:                   ',num2str(var(revision_f_qf_gdp_uc3)/var(finalc_uc3),4)])
disp(['     Rel End-point - Variance of revision QF to F - u - UC3:                     ',num2str(var(revision_f_qf_u_uc3)/var(finalc_uc3),4)])
disp(['     Rel End-point - Variance of revision QF to F - pi - UC3:                    ',num2str(var(revision_f_qf_pi_uc3)/var(finalc_uc3),4)])
disp(['  Rel Param. Inst. - Variance of revision QRT to QF - UC3:                    ',num2str(var(revision_qf_qrt_uc3)/var(finalc_uc3),4)])
disp(['     Rel Param. Inst. - Variance of revision QRT to QF - GDP - UC3:              ',num2str(var(revision_qf_qrt_gdp_uc3)/var(finalc_uc3),4)])
disp(['     Rel Param. Inst. - Variance of revision QRT to QF - u - UC3:                ',num2str(var(revision_qf_qrt_u_uc3)/var(finalc_uc3),4)])
disp(['     Rel Param. Inst. - Variance of revision QRT to QF - pi - UC3:               ',num2str(var(revision_qf_qrt_pi_uc3)/var(finalc_uc3),4)])
disp(['  Rel Data Revision - Variance of revision RT to QRT - UC3:                   ',num2str(var(revision_qrt_rt_uc3)/var(finalc_uc3),4)])
disp(['     Rel Data Revision - Variance of revision RT to QRT - GDP - UC3:             ',num2str(var(revision_qrt_rt_gdp_uc3)/var(finalc_uc3),4)])
disp(['     Rel Data Revision - Variance of revision RT to QRT - u - UC3:               ',num2str(var(revision_qrt_rt_u_uc3)/var(finalc_uc3),4)])
disp(['     Rel Data Revision - Variance of revision RT to QRT - pi - UC3:              ',num2str(var(revision_qrt_rt_pi_uc3)/var(finalc_uc3),4)])
disp(['  Rel Residual - UC3:                                                         ',num2str((var(revision_f_rt_uc3)-var(revision_f_qf_uc3)-var(revision_qf_qrt_uc3)-var(revision_qrt_rt_uc3))/var(finalc_uc3),4)])
disp('   ')


disp('   ')
disp('UC2 - Inflation   ')
disp('   ')
disp(['Noise-to-signal ratio - UC2(GDP,pi):                                ',num2str(std(revision_f_rt_uc2_pi)/std(finalc_uc2_pi),4)])
disp(['Variance of final estimate of output gap - UC2(GDP,pi):             ',num2str(var(finalc_uc2_pi),4)])
disp(['Variance of revision RT to F - UC2(GDP,pi):                         ',num2str(var(revision_f_rt_uc2_pi),4)])
disp(['  Variance of revision RT to F - GDP  - UC2(GDP,pi):                      ',num2str(var(revision_f_rt_gdp_uc2_pi),4)])
disp(['  Variance of revision RT to F - pi  - UC2(GDP,pi):                       ',num2str(var(revision_f_rt_pi_uc2_pi),4)])
disp(['  Variance of revision RT to F - residual - UC2(GDP,pi):                  ',num2str((var(revision_f_rt_uc2_pi)-var(revision_f_rt_gdp_uc2_pi)-var(revision_f_rt_pi_uc2_pi)),4)])

disp('   ')
disp(['  End-point - Variance of revision QF to F - UC2(GDP,pi):                 ',num2str(var(revision_f_qf_uc2_pi),4)])
disp(['     End-point - Variance of revision QF to F - GDP - UC2(GDP,pi):           ',num2str(var(revision_f_qf_gdp_uc2_pi),4)])
disp(['     End-point - Variance of revision QF to F - pi - UC2(GDP,pi):            ',num2str(var(revision_f_qf_pi_uc2_pi),4)])
disp(['  Param. Inst. - Variance of revision QRT to QF - UC2(GDP,pi):            ',num2str(var(revision_qf_qrt_uc2_pi),4)])
disp(['     Param. Inst. - Variance of revision QRT to QF - GDP - UC2(GDP,pi):      ',num2str(var(revision_qf_qrt_gdp_uc2_pi),4)])
disp(['     Param. Inst. - Variance of revision QRT to QF - pi - UC2(GDP,pi):       ',num2str(var(revision_qf_qrt_pi_uc2_pi),4)])
disp(['  Data Revision - Variance of revision RT to QRT - UC2(GDP,pi):           ',num2str(var(revision_qrt_rt_uc2_pi),4)])
disp(['     Data Revision - Variance of revision RT to QRT - GDP - UC2(GDP,pi):     ',num2str(var(revision_qrt_rt_gdp_uc2_pi),4)])
disp(['     Data Revision - Variance of revision RT to QRT - pi - UC2(GDP,pi):      ',num2str(var(revision_qrt_rt_pi_uc2_pi),4)])
disp(['  Residual - UC2(GDP,pi):                                                 ',num2str((var(revision_f_rt_uc2_pi)-var(revision_f_qf_uc2_pi)-var(revision_qf_qrt_uc2_pi)-var(revision_qrt_rt_uc2_pi)),4)])
disp('   ')

disp('   ')
disp(['Rel Variance of revision RT to F - UC2(GDP,pi):                         ',num2str(var(revision_f_rt_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['  Rel End-point - Variance of revision QF to F - UC2(GDP,pi):                 ',num2str(var(revision_f_qf_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['     Rel End-point - Variance of revision QF to F - GDP - UC2(GDP,pi):           ',num2str(var(revision_f_qf_gdp_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['     Rel End-point - Variance of revision QF to F - pi - UC2(GDP,pi):            ',num2str(var(revision_f_qf_pi_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['  Rel Param. Inst. - Variance of revision QRT to QF - UC2(GDP,pi):            ',num2str(var(revision_qf_qrt_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['     Rel Param. Inst. - Variance of revision QRT to QF - GDP - UC2(GDP,pi):      ',num2str(var(revision_qf_qrt_gdp_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['     Rel Param. Inst. - Variance of revision QRT to QF - pi - UC2(GDP,pi):       ',num2str(var(revision_qf_qrt_pi_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['  Rel Data Revision - Variance of revision RT to QRT - UC2(GDP,pi):           ',num2str(var(revision_qrt_rt_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['     Rel Data Revision - Variance of revision RT to QRT - GDP - UC2(GDP,pi):     ',num2str(var(revision_qrt_rt_gdp_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['     Rel Data Revision - Variance of revision RT to QRT - pi - UC2(GDP,pi):      ',num2str(var(revision_qrt_rt_pi_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['  Rel Residual - UC2(GDP,pi):                                                 ',num2str((var(revision_f_rt_uc2_pi)-var(revision_f_qf_uc2_pi)-var(revision_qf_qrt_uc2_pi)-var(revision_qrt_rt_uc2_pi))/var(finalc_uc2_pi),4)])
disp('   ')



disp('   ')
disp('UC2 - Capacity Utilization   ')
disp('   ')
disp(['Noise-to-signal ratio - UC2(GDP,cu):                                ',num2str(std(revision_f_rt_uc2_cu)/std(finalc_uc2_cu),4)])
disp(['Variance of final estimate of output gap - UC2(GDP,cu):             ',num2str(var(finalc_uc2_cu),4)])
disp(['Variance of revision RT to F - UC2(GDP,cu):                         ',num2str(var(revision_f_rt_uc2_cu),4)])
disp(['Variance of revision RT to F - GDP - UC2(GDP,cu ):                        ',num2str(var(revision_f_rt_gdp_uc2_cu),4)])
disp(['Variance of revision RT to F - cu - UC2(GDP,cu):                          ',num2str(var(revision_f_rt_cu_uc2_cu),4)])
disp(['Variance of revision RT to F - residual - UC2(GDP,cu):                    ',num2str((var(revision_f_rt_uc2_cu)-var(revision_f_rt_gdp_uc2_cu)-var(revision_f_rt_cu_uc2_cu)),4)])
disp('   ')
disp(['  End-point - Variance of revision QF to F - UC2(GDP,cu):                 ',num2str(var(revision_f_qf_uc2_cu),4)])
disp(['     End-point - Variance of revision QF to F - GDP - UC2(GDP,cu):           ',num2str(var(revision_f_qf_gdp_uc2_cu),4)])
disp(['     End-point - Variance of revision QF to F - cu - UC2(GDP,cu):            ',num2str(var(revision_f_qf_cu_uc2_cu),4)])
disp(['  Param. Inst. - Variance of revision QRT to QF - UC2(GDP,cu):            ',num2str(var(revision_qf_qrt_uc2_cu),4)])
disp(['     Param. Inst. - Variance of revision QRT to QF - GDP - UC2(GDP,cu):      ',num2str(var(revision_qf_qrt_gdp_uc2_cu),4)])
disp(['     Param. Inst. - Variance of revision QRT to QF - cu - UC2(GDP,cu):       ',num2str(var(revision_qf_qrt_cu_uc2_cu),4)])
disp(['  Data Revision - Variance of revision RT to QRT - UC2(GDP,cu):           ',num2str(var(revision_qrt_rt_uc2_cu),4)])
disp(['     Data Revision - Variance of revision RT to QRT - GDP - UC2(GDP,cu):     ',num2str(var(revision_qrt_rt_gdp_uc2_cu),4)])
disp(['     Data Revision - Variance of revision RT to QRT - cu - UC2(GDP,cu):           ',num2str(var(revision_qrt_rt_cu_uc2_cu),4)])
disp([' Residual - UC2(GDP,cu):                                                  ',num2str((var(revision_f_rt_uc2_cu)-var(revision_f_qf_uc2_cu)-var(revision_qf_qrt_uc2_cu)-var(revision_qrt_rt_uc2_cu)),4)])
disp('   ')

disp('   ')
disp(['Rel Variance of revision RT to F - UC2(GDP,cu):                         ',num2str(var(revision_f_rt_uc2_cu)/var(finalc_uc2_cu),4)])
disp(['  Rel End-point - Variance of revision QF to F - UC2(GDP,cu):                 ',num2str(var(revision_f_qf_uc2_cu)/var(finalc_uc2_cu),4)])
disp(['     Rel End-point - Variance of revision QF to F - GDP - UC2(GDP,cu):           ',num2str(var(revision_f_qf_gdp_uc2_cu)/var(finalc_uc2_cu),4)])
disp(['     Rel End-point - Variance of revision QF to F - cu - UC2(GDP,cu):            ',num2str(var(revision_f_qf_cu_uc2_cu)/var(finalc_uc2_cu),4)])
disp(['  Rel Param. Inst. - Variance of revision QRT to QF - UC2(GDP,cu):            ',num2str(var(revision_qf_qrt_uc2_cu)/var(finalc_uc2_cu),4)])
disp(['     Rel Param. Inst. - Variance of revision QRT to QF - GDP - UC2(GDP,cu):      ',num2str(var(revision_qf_qrt_gdp_uc2_cu)/var(finalc_uc2_cu),4)])
disp(['     Rel Param. Inst. - Variance of revision QRT to QF - cu - UC2(GDP,cu):       ',num2str(var(revision_qf_qrt_cu_uc2_cu)/var(finalc_uc2_cu),4)])
disp(['  Rel Data Revision - Variance of revision RT to QRT - UC2(GDP,cu):           ',num2str(var(revision_qrt_rt_uc2_cu)/var(finalc_uc2_cu),4)])
disp(['     Rel Data Revision - Variance of revision RT to QRT - GDP - UC2(GDP,cu):     ',num2str(var(revision_qrt_rt_gdp_uc2_cu)/var(finalc_uc2_cu),4)])
disp(['     Rel Data Revision - Variance of revision RT to QRT - cu - UC2(GDP,cu):           ',num2str(var(revision_qrt_rt_cu_uc2_cu)/var(finalc_uc2_cu),4)])
disp([' Rel Residual - UC2(GDP,cu):                                                  ',num2str((var(revision_f_rt_uc2_cu)-var(revision_f_qf_uc2_cu)-var(revision_qf_qrt_uc2_cu)-var(revision_qrt_rt_uc2_cu))/var(finalc_uc2_cu),4)])
disp('   ')



disp('   ')
disp('   ')
disp('HP Garratt   ')
disp('   ')
disp(['Noise-to-signal ratio - HP Garratt(GDP):                                   ',num2str(std(revision_f_rt_hp_gar)/std(finalc_hp_gar),4)])
disp(['Variance of final estimate of output gap - HP Garratt(GDP):                ',num2str(var(finalc_hp_gar),4)])
disp(['Variance of revision RT to F - HP Garratt(GDP):                            ',num2str(var(revision_f_rt_hp_gar),4)])
disp('   ')
disp(['  End-point - Variance of revision QF to F - HP Garratt(GDP):                    ',num2str(var(revision_f_qf_hp_gar),4)])
disp(['  Param. Inst. - Variance of revision QRT to QF - HP Garratt(GDP):               ',num2str(var(revision_qf_qrt_hp_gar),4)])
disp(['  Data Revision - Variance of revision RT to QRT - HP Garratt(GDP):              ',num2str(var(revision_qrt_rt_hp_gar),4)])
disp(['  Residual - HP Garratt(GDP):                                                    ',num2str((var(revision_f_rt_hp_gar)-var(revision_f_qf_hp_gar)-var(revision_qf_qrt_hp_gar)-var(revision_qrt_rt_hp_gar)),4)])
disp('   ')

%THE FUCKING TABLE 4 DEAR LORD

disp('-----------')
disp(' TABLE 4') 

disp(' ')
disp(['Rel Variance of revision RT to F - HP:                         ',num2str(var(revision_f_rt_hp)/var(finalc_hp),4)])
disp(['Rel Variance of revision RT to F - UC1:                         ',num2str(var(revision_f_rt_uc1)/var(finalc_uc1),4)])
disp(['Rel Variance of revision RT to F - UC2:                         ',num2str(var(revision_f_rt_uc2)/var(finalc_uc2),4)])
disp(['Rel Variance of revision RT to F - UC3:                         ',num2str(var(revision_f_rt_uc3)/var(finalc_uc3),4)])
disp(['Rel Variance of revision RT to F - UC2PI:                         ',num2str(var(revision_f_rt_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['Rel Variance of revision RT to F - UC2CU:                         ',num2str(var(revision_f_rt_uc2_cu)/var(finalc_uc2_cu),4)])
disp(' ')

disp(['  Rel End-point - Variance of revision QF to F - HP:                    ',num2str(var(revision_f_qf_hp)/var(finalc_hp),4)])
disp(['  Rel End-point - Variance of revision QF to F - UC1:                    ',num2str(var(revision_f_qf_uc1)/var(finalc_uc1),4)])
disp(['  Rel End-point - Variance of revision QF to F - UC2:                    ',num2str(var(revision_f_qf_uc2)/var(finalc_uc2),4)])
disp(['  Rel End-point - Variance of revision QF to F - UC3:                    ',num2str(var(revision_f_qf_uc3)/var(finalc_uc3),4)])
disp(['  Rel End-point - Variance of revision QF to F - UCPI:                    ',num2str(var(revision_f_qf_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['  Rel End-point - Variance of revision QF to F - UCCU:                    ',num2str(var(revision_f_qf_uc2_cu)/var(finalc_uc2_cu),4)])
disp(' ')


disp(['  Rel Param. Inst. - Variance of revision QRT to QF - HP:            ',num2str(var(revision_qf_qrt_hp)/var(finalc_hp),4)])
disp(['  Rel Param. Inst. - Variance of revision QRT to QF - UC1:            ',num2str(var(revision_qf_qrt_uc1)/var(finalc_uc1),4)])
disp(['  Rel Param. Inst. - Variance of revision QRT to QF - UC2:            ',num2str(var(revision_qf_qrt_uc2)/var(finalc_uc2),4)])
disp(['  Rel Param. Inst. - Variance of revision QRT to QF - UC3:            ',num2str(var(revision_qf_qrt_uc3)/var(finalc_uc3),4)])
disp(['  Rel Param. Inst. - Variance of revision QRT to QF - UCPI:            ',num2str(var(revision_qf_qrt_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['  Rel Param. Inst. - Variance of revision QRT to QF - UCCU:            ',num2str(var(revision_qf_qrt_uc2_cu)/var(finalc_uc2_cu),4)])
disp(' ')


disp(['  Rel Data Revision - Variance of revision RT to QRT - HP:           ',num2str(var(revision_qrt_rt_hp)/var(finalc_hp),4)])
disp(['  Rel Data Revision - Variance of revision RT to QRT - UC1:           ',num2str(var(revision_qrt_rt_uc1)/var(finalc_uc1),4)])
disp(['  Rel Data Revision - Variance of revision RT to QRT - UC2:           ',num2str(var(revision_qrt_rt_uc2)/var(finalc_uc2),4)])
disp(['  Rel Data Revision - Variance of revision RT to QRT - UC3:           ',num2str(var(revision_qrt_rt_uc3)/var(finalc_uc3),4)])
disp(['  Rel Data Revision - Variance of revision RT to QRT - UC2PI:           ',num2str(var(revision_qrt_rt_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['  Rel Data Revision - Variance of revision RT to QRT - UC2CU:           ',num2str(var(revision_qrt_rt_uc2_cu)/var(finalc_uc2_cu),4)])
disp(' ')

disp([' Rel Residual - HP:                                                  ',num2str((var(revision_f_rt_hp)-var(revision_f_qf_hp)-var(revision_qf_qrt_hp)-var(revision_qrt_rt_hp))/var(finalc_hp),4)])
disp([' Rel Residual - UC1:                                                 ',num2str((var(revision_f_rt_uc1)-var(revision_f_qf_uc1)-var(revision_qf_qrt_uc1)-var(revision_qrt_rt_uc1))/var(finalc_uc1),4)])
disp([' Rel Residual - UC2:                                                 ',num2str((var(revision_f_rt_uc2)-var(revision_f_qf_uc2)-var(revision_qf_qrt_uc2)-var(revision_qrt_rt_uc2))/var(finalc_uc2),4)])
disp([' Rel Residual - UC3:                                                 ',num2str((var(revision_f_rt_uc3)-var(revision_f_qf_uc3)-var(revision_qf_qrt_uc3)-var(revision_qrt_rt_uc3))/var(finalc_uc3),4)])
disp([' Rel Residual - UC2PI:                                               ',num2str((var(revision_f_rt_uc2_pi)-var(revision_f_qf_uc2_pi)-var(revision_qf_qrt_uc2_pi)-var(revision_qrt_rt_uc2_pi))/var(finalc_uc2_pi),4)])
disp([' Rel Residual - UC2CU:                                               ',num2str((var(revision_f_rt_uc2_cu)-var(revision_f_qf_uc2_cu)-var(revision_qf_qrt_uc2_cu)-var(revision_qrt_rt_uc2_cu))/var(finalc_uc2_cu),4)])

disp('   ')

disp(['     Rel End Point - Variance of revision QRT to QF - GDP - UC2:       ',num2str(var(revision_f_qf_gdp_uc2)/var(finalc_uc2),4)])
disp(['     Rel End Point - Variance of revision QRT to QF - GDP - UC3:       ',num2str(var(revision_f_qf_gdp_uc3)/var(finalc_uc3),4)])
disp(['     Rel End Point - Variance of revision QRT to QF - GDP - UC2PI:       ',num2str(var(revision_f_qf_gdp_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['     Rel End Point - Variance of revision QRT to QF - GDP - UC2CU:       ',num2str(var(revision_f_qf_gdp_uc2_cu)/var(finalc_uc2_cu),4)])
disp(['     Rel End Point - Variance of revision QRT to QF - u - UC2:         ',num2str(var(revision_f_qf_u_uc2)/var(finalc_uc2),4)])
disp(['     Rel End Point - Variance of revision QRT to QF - u - UC3:         ',num2str(var(revision_f_qf_u_uc3)/var(finalc_uc3),4)])
disp(['     Rel End Point - Variance of revision QRT to QF - pi - UC3:         ',num2str(var(revision_f_qf_pi_uc3)/var(finalc_uc3),4)])
disp(['     Rel End Point - Variance of revision QRT to QF - pi - UC2PI:         ',num2str(var(revision_f_qf_pi_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['     Rel End Point - Variance of revision QRT to QF - CU - UC2CU:         ',num2str(var(revision_f_qf_cu_uc2_cu)/var(finalc_uc2_cu),4)])
disp('   ')


disp(['     Rel Param. Inst. - Variance of revision QRT to QF - GDP - UC2:       ',num2str(var(revision_qf_qrt_gdp_uc2)/var(finalc_uc2),4)])
disp(['     Rel Param. Inst. - Variance of revision QRT to QF - GDP - UC3:       ',num2str(var(revision_qf_qrt_gdp_uc3)/var(finalc_uc3),4)])
disp(['     Rel Param. Inst. - Variance of revision QRT to QF - GDP - UC2PI:       ',num2str(var(revision_qf_qrt_gdp_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['     Rel Param. Inst. - Variance of revision QRT to QF - GDP - UC2CU:       ',num2str(var(revision_qf_qrt_gdp_uc2_cu)/var(finalc_uc2_cu),4)])
disp(['     Rel Param. Inst. - Variance of revision QRT to QF - u - UC2:         ',num2str(var(revision_qf_qrt_u_uc2)/var(finalc_uc2),4)])
disp(['     Rel Param. Inst. - Variance of revision QRT to QF - u - UC3:         ',num2str(var(revision_qf_qrt_u_uc3)/var(finalc_uc3),4)])
disp(['     Rel Param. Inst. - Variance of revision QRT to QF - pi - UC3:         ',num2str(var(revision_qf_qrt_pi_uc3)/var(finalc_uc3),4)])
disp(['     Rel Param. Inst. - Variance of revision QRT to QF - pi - UC2PI:         ',num2str(var(revision_qf_qrt_pi_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['     Rel Param. Inst. - Variance of revision QRT to QF - CU - UC2CU:         ',num2str(var(revision_qf_qrt_cu_uc2_cu)/var(finalc_uc2_cu),4)])

disp('   ')

disp(['     Rel Data Revision - Variance of revision RT to QRT - GDP - UC2:     ',num2str(var(revision_qrt_rt_gdp_uc2)/var(finalc_uc2),4)])
disp(['     Rel Data Revision - Variance of revision RT to QRT - GDP - UC3:     ',num2str(var(revision_qrt_rt_gdp_uc3)/var(finalc_uc3),4)])
disp(['     Rel Data Revision - Variance of revision RT to QRT - GDP - UC2PI:     ',num2str(var(revision_qrt_rt_gdp_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['     Rel Data Revision - Variance of revision RT to QRT - GDP - UC2CU:     ',num2str(var(revision_qrt_rt_gdp_uc2_cu)/var(finalc_uc2_cu),4)])
disp(['     Rel Data Revision - Variance of revision RT to QRT - U - UC2:     ',num2str(var(revision_qrt_rt_u_uc2)/var(finalc_uc2),4)])
disp(['     Rel Data Revision - Variance of revision RT to QRT - U - UC3:     ',num2str(var(revision_qrt_rt_u_uc3)/var(finalc_uc3),4)])
disp(['     Rel Data Revision - Variance of revision RT to QRT - PI - UC3:     ',num2str(var(revision_qrt_rt_pi_uc3)/var(finalc_uc3),4)])
disp(['     Rel Data Revision - Variance of revision RT to QRT - PI - UC2PI:     ',num2str(var(revision_qrt_rt_pi_uc2_pi)/var(finalc_uc2_pi),4)])
disp(['     Rel Data Revision - Variance of revision RT to QRT - CU - UC2CU:     ',num2str(var(revision_qrt_rt_cu_uc2_cu)/var(finalc_uc2_cu),4)])


disp('-----------')
end


if std_results == 1


disp('   ')
disp('   ')
disp('   ')
disp('   ')
disp('   ')
disp('Standard Deviations decomposition   ')
disp('   ')
disp('   ')


disp('   ')
disp('   ')
disp('UC1   ')
disp('   ')
disp(['Standard deviation of final estimate of output gap - UC1(GDP):     ',num2str(std(finalc_uc1),1)])
disp(['Standard deviation of revision RT to F - UC1(GDP):                 ',num2str(std(revision_f_rt_uc1),1)])
disp('   ')
disp(['  End-point - Standard deviation of revision QF to F - UC1(GDP):                        ',num2str(std(revision_f_qf_uc1),1)])
disp(['  Param. Inst. - Standard deviation of revision QRT to QF - UC1(GDP):                   ',num2str(std(revision_qf_qrt_uc1),1)])
disp(['  Data Revision - Standard deviation of revision RT to QRT - UC1(GDP):                  ',num2str(std(revision_qrt_rt_uc1),1)])


disp('   ')
disp('   ')
disp('HP   ')
disp('   ')
disp(['Standard deviation of final estimate of output gap - HP(GDP):     ',num2str(std(finalc_hp),1)])
disp(['Standard deviation of revision RT to F - HP(GDP):                 ',num2str(std(revision_f_rt_hp),1)])
disp('   ')
disp(['  End-point - Standard deviation of revision QF to F - HP(GDP):                        ',num2str(std(revision_f_qf_hp),1)])
disp(['  Param. Inst. - Standard deviation of revision QRT to QF - HP(GDP):                   ',num2str(std(revision_qf_qrt_hp),1)])
disp(['  Data Revision - Standard deviation of revision RT to QRT - HP(GDP):                  ',num2str(std(revision_qrt_rt_hp),1)])

disp('   ')
disp('   ')
disp('HP Garratt   ')
disp('   ')
disp(['Standard deviation of final estimate of output gap - HP Garratt(GDP):     ',num2str(std(finalc_hp_gar),1)])
disp(['Standard deviation of revision RT to F - HP Garratt(GDP):                 ',num2str(std(revision_f_rt_hp_gar),1)])
disp('   ')
disp(['  End-point - Standard deviation of revision QF to F - HP Garratt(GDP):                        ',num2str(std(revision_f_qf_hp_gar),1)])
disp(['  Param. Inst. - Standard deviation of revision QRT to QF - HP Garratt(GDP):                   ',num2str(std(revision_qf_qrt_hp_gar),1)])
disp(['  Data Revision - Standard deviation of revision RT to QRT - HP Garratt(GDP):                  ',num2str(std(revision_qrt_rt_hp_gar),1)])

disp('   ')
disp('   ')
disp('UC2 - Unemployment   ')
disp('   ')
disp(['Standard deviation of final estimate of output gap - UC2(GDP,u):   ',num2str(std(finalc_uc2),1)])
disp(['Standard deviation of revision RT to F - UC2(GDP,u):               ',num2str(std(revision_f_rt_uc2),1)])
disp(['Standard deviation of revision RT to F - GDP  - UC2(GDP,u):                             ',num2str(std(revision_f_rt_gdp_uc2),1)])
disp(['Standard deviation of revision RT to F - u  - UC2(GDP,u):                               ',num2str(std(revision_f_rt_u_uc2),1)])
disp('   ')
disp(['  End-point - Standard deviation of revision QF to F - UC2(GDP,u):                      ',num2str(std(revision_f_qf_uc2),1)])
disp(['     End-point - Standard deviation of revision QF to F - GDP - UC2(GDP,u):                       ',num2str(std(revision_f_qf_gdp_uc2),1)])
disp(['     End-point - Standard deviation of revision QF to F - u - UC2(GDP,u):                         ',num2str(std(revision_f_qf_u_uc2),1)])
disp(['  Param. Inst. - Standard deviation of revision QRT to QF - UC2(GDP,u):                 ',num2str(std(revision_qf_qrt_uc2),1)])
disp(['     Param. Inst. - Standard deviation of revision QRT to QF - GDP - UC2(GDP,u):                  ',num2str(std(revision_qf_qrt_gdp_uc2),1)])
disp(['     Param. Inst. - Standard deviation of revision QRT to QF - u - UC2(GDP,u):                    ',num2str(std(revision_qf_qrt_u_uc2),1)])
disp(['  Data Revision - Standard deviation of revision RT to QRT - UC2(GDP,u):                ',num2str(std(revision_qrt_rt_uc2),1)])
disp(['     Data Revision - Standard deviation of revision RT to QRT - GDP - UC2(GDP,u):                 ',num2str(std(revision_qrt_rt_gdp_uc2),1)])
disp(['     Data Revision - Standard deviation of revision RT to QRT - u - UC2(GDP,u):                   ',num2str(std(revision_qrt_rt_u_uc2),1)])
disp('   ')
disp('   ')

disp('   ')
disp('   ')
disp('UC2 - Capacity Utilization   ')
disp('   ')
disp(['Standard deviation of final estimate of output gap - UC2(GDP,cu):   ',num2str(std(finalc_uc2_cu),1)])
disp(['Standard deviation of revision RT to F - UC2(GDP,cu):               ',num2str(std(revision_f_rt_uc2_cu),1)])
disp(['Standard deviation of revision RT to F - GDP  - UC2(GDP,cu):                             ',num2str(std(revision_f_rt_gdp_uc2_cu),1)])
disp(['Standard deviation of revision RT to F - cu  - UC2(GDP,cu):                               ',num2str(std(revision_f_rt_cu_uc2_cu),1)])
disp('   ')
disp(['  End-point - Standard deviation of revision QF to F - UC2(GDP,cu):                      ',num2str(std(revision_f_qf_uc2_cu),1)])
disp(['     End-point - Standard deviation of revision QF to F - GDP - UC2(GDP,cu):                       ',num2str(std(revision_f_qf_gdp_uc2_cu),1)])
disp(['     End-point - Standard deviation of revision QF to F - cu - UC2(GDP,cu):                         ',num2str(std(revision_f_qf_cu_uc2_cu),1)])
disp(['  Param. Inst. - Standard deviation of revision QRT to QF - UC2(GDP,cu):                 ',num2str(std(revision_qf_qrt_uc2_cu),1)])
disp(['     Param. Inst. - Standard deviation of revision QRT to QF - GDP - UC2(GDP,cu):                  ',num2str(std(revision_qf_qrt_gdp_uc2_cu),1)])
disp(['     Param. Inst. - Standard deviation of revision QRT to QF - cu - UC2(GDP,cu):                    ',num2str(std(revision_qf_qrt_cu_uc2_cu),1)])
disp(['  Data Revision - Standard deviation of revision RT to QRT - UC2(GDP,cu):                ',num2str(std(revision_qrt_rt_uc2_cu),1)])
disp(['     Data Revision - Standard deviation of revision RT to QRT - GDP - UC2(GDP,cu):                 ',num2str(std(revision_qrt_rt_gdp_uc2_cu),1)])
disp(['     Data Revision - Standard deviation of revision RT to QRT - cu - UC2(GDP,cu):                   ',num2str(std(revision_qrt_rt_cu_uc2_cu),1)])
disp('   ')

disp('   ')
disp('   ')
disp('UC2 - Inflation   ')
disp('   ')
disp(['Standard deviation of final estimate of output gap - UC2(GDP,pi):   ',num2str(std(finalc_uc2_pi),1)])
disp(['Standard deviation of revision RT to F - UC2(GDP,pi):               ',num2str(std(revision_f_rt_uc2_pi),1)])
disp(['Standard deviation of revision RT to F - GDP  - UC2(GDP,pi):                             ',num2str(std(revision_f_rt_gdp_uc2_pi),1)])
disp(['Standard deviation of revision RT to F - pi  - UC2(GDP,pi):                               ',num2str(std(revision_f_rt_pi_uc2_pi),1)])
disp('   ')
disp(['  End-point - Standard deviation of revision QF to F - UC2(GDP,pi):                      ',num2str(std(revision_f_qf_uc2_pi),1)])
disp(['     End-point - Standard deviation of revision QF to F - GDP - UC2(GDP,pi):                       ',num2str(std(revision_f_qf_gdp_uc2_pi),1)])
disp(['     End-point - Standard deviation of revision QF to F - pi - UC2(GDP,pi):                         ',num2str(std(revision_f_qf_pi_uc2_pi),1)])
disp(['  Param. Inst. - Standard deviation of revision QRT to QF - UC2(GDP,pi):                 ',num2str(std(revision_qf_qrt_uc2_pi),1)])
disp(['     Param. Inst. - Standard deviation of revision QRT to QF - GDP - UC2(GDP,pi):                  ',num2str(std(revision_qf_qrt_gdp_uc2_pi),1)])
disp(['     Param. Inst. - Standard deviation of revision QRT to QF - pi - UC2(GDP,pi):                    ',num2str(std(revision_qf_qrt_pi_uc2_pi),1)])
disp(['  Data Revision - Standard deviation of revision RT to QRT - UC2(GDP,pi):                ',num2str(std(revision_qrt_rt_uc2_pi),1)])
disp(['     Data Revision - Standard deviation of revision RT to QRT - GDP - UC2(GDP,pi):                 ',num2str(std(revision_qrt_rt_gdp_uc2_pi),1)])
disp(['     Data Revision - Standard deviation of revision RT to QRT - pi - UC2(GDP,pi):                   ',num2str(std(revision_qrt_rt_pi_uc2_pi),1)])
    
disp('   ')
disp('   ')
disp('UC3   ')
disp('   ')
disp(['Standard deviation of final estimate of output gap - UC3:   ',num2str(std(finalc_uc3),1)])
disp(['Standard deviation of revision RT to F - UC3:               ',num2str(std(revision_f_rt_uc3),1)])
disp(['Standard deviation of revision RT to F - GDP  - UC3:                             ',num2str(std(revision_f_rt_gdp_uc3),1)])
disp(['Standard deviation of revision RT to F - u  - UC3:                               ',num2str(std(revision_f_rt_u_uc3),1)])
disp(['Standard deviation of revision RT to F - pi  - UC3:                              ',num2str(std(revision_f_rt_pi_uc3),1)])
disp('   ')
disp(['  End-point - Standard deviation of revision QF to F - UC3:                      ',num2str(std(revision_f_qf_uc3),1)])
disp(['     End-point - Standard deviation of revision QF to F - GDP - UC3:                       ',num2str(std(revision_f_qf_gdp_uc3),1)])
disp(['     End-point - Standard deviation of revision QF to F - u - UC3:                         ',num2str(std(revision_f_qf_u_uc3),1)])
disp(['  Param. Inst. - Standard deviation of revision QRT to QF - UC3:                 ',num2str(std(revision_qf_qrt_uc3),1)])
disp(['     Param. Inst. - Standard deviation of revision QRT to QF - GDP - UC3:                  ',num2str(std(revision_qf_qrt_gdp_uc3),1)])
disp(['     Param. Inst. - Standard deviation of revision QRT to QF - u - UC3:                    ',num2str(std(revision_qf_qrt_u_uc3),1)])
disp(['  Data Revision - Standard deviation of revision RT to QRT - UC3:                ',num2str(std(revision_qrt_rt_uc3),1)])
disp(['     Data Revision - Standard deviation of revision RT to QRT - GDP - UC3:                 ',num2str(std(revision_qrt_rt_gdp_uc3),1)])
disp(['     Data Revision - Standard deviation of revision RT to QRT - u - UC3:                   ',num2str(std(revision_qrt_rt_u_uc3),1)])

end


if NSR_results == 1


disp('   ')
disp('   ')
disp('   ')
disp('   ')
disp('   ')
disp('Noise-to-signal ratios decomposition   ')
disp('   ')
disp('   ')


disp('   ')
disp('   ')
disp('UC1   ')
disp('   ')
disp(['Noise-to-signal ratio - UC1(GDP):                                  ',num2str(std(revision_f_rt_uc1)/std(finalc_uc1),2)])
disp('   ')
disp(['  End-point - Noise-to-signal ratio of revision QF to F - UC1(GDP):                        ',num2str(std(revision_f_qf_uc1)/std(finalc_uc1),2)])
disp(['  Param. Inst. - Noise-to-signal ratio of revision QRT to QF - UC1(GDP):                   ',num2str(std(revision_qf_qrt_uc1)/std(finalc_uc1),2)])
disp(['  Data Revision - Noise-to-signal ratio of revision RT to QRT - UC1(GDP):                  ',num2str(std(revision_qrt_rt_uc1)/std(finalc_uc1),2)])
disp(['  Residual - UC1(GDP):                                                                     ',num2str((std(revision_f_rt_uc1)/std(finalc_uc1)-std(revision_f_qf_uc1)/std(finalc_uc1)- std(revision_qf_qrt_uc1)/std(finalc_uc1)-std(revision_qrt_rt_uc1)/std(finalc_uc1)),2)])


disp('   ')
disp('   ')
disp('HP   ')
disp('   ')
disp(['Noise-to-signal ratio - HP(GDP):                                  ',num2str(std(revision_f_rt_hp)/std(finalc_hp),2)])
disp('   ')
disp(['  End-point - Noise-to-signal ratio of revision QF to F - HP(GDP):                        ',num2str(std(revision_f_qf_hp)/std(finalc_hp),2)])
disp(['  Param. Inst. - Noise-to-signal ratio of revision QRT to QF - HP(GDP):                   ',num2str(std(revision_qf_qrt_hp)/std(finalc_hp),2)])
disp(['  Data Revision - Noise-to-signal ratio of revision RT to QRT - HP(GDP):                  ',num2str(std(revision_qrt_rt_hp)/std(finalc_hp),2)])
disp(['  Residual - HP(GDP):                                                                     ',num2str((std(revision_f_rt_hp)/std(finalc_hp)-std(revision_f_qf_hp)/std(finalc_hp)- std(revision_qf_qrt_hp)/std(finalc_hp)-std(revision_qrt_rt_hp)/std(finalc_hp)),2)])

disp('   ')
disp('   ')
disp('HP Garratt   ')
disp('   ')
disp(['Noise-to-signal ratio - HP Garratt(GDP):                                  ',num2str(std(revision_f_rt_hp_gar)/std(finalc_hp_gar),2)])
disp('   ')
disp(['  End-point - Noise-to-signal ratio of revision QF to F - HP Garratt(GDP):                        ',num2str(std(revision_f_qf_hp_gar)/std(finalc_hp_gar),2)])
disp(['  Param. Inst. - Noise-to-signal ratio of revision QRT to QF - HP Garratt(GDP):                   ',num2str(std(revision_qf_qrt_hp_gar)/std(finalc_hp_gar),2)])
disp(['  Data Revision - Noise-to-signal ratio of revision RT to QRT - HP Garratt(GDP):                  ',num2str(std(revision_qrt_rt_hp_gar)/std(finalc_hp_gar),2)])
disp(['  Residual - HP Garratt(GDP):                                                                     ',num2str((std(revision_f_rt_hp_gar)/std(finalc_hp_gar)-std(revision_f_qf_hp_gar)/std(finalc_hp_gar)- std(revision_qf_qrt_hp_gar)/std(finalc_hp_gar)-std(revision_qrt_rt_hp_gar)/std(finalc_hp_gar)),2)])

disp('   ')
disp('   ')
disp('UC2 - Unemployment   ')
disp('   ')
disp(['Noise-to-signal ratio - UC2(GDP,u):                                ',num2str(std(revision_f_rt_uc2)/std(finalc_uc2),2)])
disp('   ')
disp(['  End-point - Noise-to-signal ratio of revision QF to F - UC2(GDP,u):                      ',num2str(std(revision_f_qf_uc2)/std(finalc_uc2),2)])
disp(['     End-point - Noise-to-signal ratio of revision QF to F - GDP - UC2(GDP,u):                       ',num2str(std(revision_f_qf_gdp_uc2)/std(finalc_uc2),2)])
disp(['     End-point - Noise-to-signal ratio of revision QF to F - u - UC2(GDP,u):                         ',num2str(std(revision_f_qf_u_uc2)/std(finalc_uc2),2)])
disp(['  Param. Inst. - Noise-to-signal ratio of revision QRT to QF - UC2(GDP,u):                 ',num2str(std(revision_qf_qrt_uc2)/std(finalc_uc2),2)])
disp(['     Param. Inst. - Noise-to-signal ratio of revision QRT to QF - GDP - UC2(GDP,u):                  ',num2str(std(revision_qf_qrt_gdp_uc2)/std(finalc_uc2),2)])
disp(['     Param. Inst. - Noise-to-signal ratio of revision QRT to QF - u - UC2(GDP,u):                    ',num2str(std(revision_qf_qrt_u_uc2)/std(finalc_uc2),2)])
disp(['  Data Revision - Noise-to-signal ratio of revision RT to QRT - UC2(GDP,u):                ',num2str(std(revision_qrt_rt_uc2)/std(finalc_uc2),2)])
disp(['     Data Revision - Noise-to-signal ratio of revision RT to QRT - GDP - UC2(GDP,u):                 ',num2str(std(revision_qrt_rt_gdp_uc2)/std(finalc_uc2),2)])
disp(['     Data Revision - Noise-to-signal ratio of revision RT to QRT - u - UC2(GDP,u):                   ',num2str(std(revision_qrt_rt_u_uc2)/std(finalc_uc2),2)])
disp(['  Residual - UC2(GDP,u):                                                                   ',num2str((std(revision_f_rt_uc2)/std(finalc_uc2)-std(revision_f_qf_uc2)/std(finalc_uc2)- std(revision_qf_qrt_uc2)/std(finalc_uc2)-std(revision_qrt_rt_uc2)/std(finalc_uc2)),2)])
disp('   ')
disp([' Noise-to-signal ratio due to GDP - UC2(GDP,u):                                            ',num2str(std(revision_f_rt_gdp_uc2)/std(finalc_uc2),2)])
disp([' Noise-to-signal ratio due to u - UC2(GDP,u):                                              ',num2str(std(revision_f_rt_u_uc2)/std(finalc_uc2),2)])
disp([' Residual - UC2(GDP,u):                                                                    ',num2str((std(revision_f_rt_uc2)/std(finalc_uc2)-std(revision_f_rt_gdp_uc2)/std(finalc_uc2)- std(revision_f_rt_u_uc2)/std(finalc_uc2)),2)])
disp('   ')
disp('   ')

disp('   ')
disp('   ')
disp('UC2 - Capacity Utilization   ')
disp('   ')
disp(['Noise-to-signal ratio - UC2(GDP,cu):                                ',num2str(std(revision_f_rt_uc2_cu)/std(finalc_uc2_cu),2)])
disp('   ')
disp(['  End-point - Noise-to-signal ratio of revision QF to F - UC2(GDP,cu):                      ',num2str(std(revision_f_qf_uc2_cu)/std(finalc_uc2_cu),2)])
disp(['     End-point - Noise-to-signal ratio of revision QF to F - GDP - UC2(GDP,cu):                       ',num2str(std(revision_f_qf_gdp_uc2_cu)/std(finalc_uc2_cu),2)])
disp(['     End-point - Noise-to-signal ratio of revision QF to F - cu - UC2(GDP,cu):                         ',num2str(std(revision_f_qf_cu_uc2_cu)/std(finalc_uc2_cu),2)])
disp(['  Param. Inst. - Noise-to-signal ratio of revision QRT to QF - UC2(GDP,cu):                 ',num2str(std(revision_qf_qrt_uc2_cu)/std(finalc_uc2_cu),2)])
disp(['     Param. Inst. - Noise-to-signal ratio of revision QRT to QF - GDP - UC2(GDP,cu):                  ',num2str(std(revision_qf_qrt_gdp_uc2_cu)/std(finalc_uc2_cu),2)])
disp(['     Param. Inst. - Noise-to-signal ratio of revision QRT to QF - cu - UC2(GDP,cu):                    ',num2str(std(revision_qf_qrt_cu_uc2_cu)/std(finalc_uc2_cu),2)])
disp(['  Data Revision - Noise-to-signal ratio of revision RT to QRT - UC2(GDP,cu):                ',num2str(std(revision_qrt_rt_uc2_cu)/std(finalc_uc2_cu),2)])
disp(['     Data Revision - Noise-to-signal ratio of revision RT to QRT - GDP - UC2(GDP,cu):                 ',num2str(std(revision_qrt_rt_gdp_uc2_cu)/std(finalc_uc2_cu),2)])
disp(['     Data Revision - Noise-to-signal ratio of revision RT to QRT - cu - UC2(GDP,cu):                   ',num2str(std(revision_qrt_rt_cu_uc2_cu)/std(finalc_uc2_cu),2)])
disp(['  Residual - UC2(GDP,cu):                                                                   ',num2str((std(revision_f_rt_uc2_cu)/std(finalc_uc2_cu)-std(revision_f_qf_uc2_cu)/std(finalc_uc2_cu)- std(revision_qf_qrt_uc2_cu)/std(finalc_uc2_cu)-std(revision_qrt_rt_uc2_cu)/std(finalc_uc2_cu)),2)])
disp('   ')
disp([' Noise-to-signal ratio due to GDP - UC2(GDP,cu):                                            ',num2str(std(revision_f_rt_gdp_uc2_cu)/std(finalc_uc2_cu),2)])
disp([' Noise-to-signal ratio due to cu - UC2(GDP,cu):                                             ',num2str(std(revision_f_rt_cu_uc2_cu)/std(finalc_uc2_cu),2)])
disp([' Residual - UC2(GDP,cu):                                                                    ',num2str((std(revision_f_rt_uc2_cu)/std(finalc_uc2_cu)-std(revision_f_rt_gdp_uc2_cu)/std(finalc_uc2_cu)- std(revision_f_rt_cu_uc2_cu)/std(finalc_uc2_cu)),2)])
disp('   ')
disp('   ')

disp('   ')
disp('   ')
disp('UC2 - Inflation   ')
disp('   ')
disp(['Noise-to-signal ratio - UC2(GDP,pi):                                ',num2str(std(revision_f_rt_uc2_pi)/std(finalc_uc2_pi),2)])
disp('   ')
disp(['  End-point - Noise-to-signal ratio of revision QF to F - UC2(GDP,pi):                      ',num2str(std(revision_f_qf_uc2_pi)/std(finalc_uc2_pi),2)])
disp(['     End-point - Noise-to-signal ratio of revision QF to F - GDP - UC2(GDP,pi):                       ',num2str(std(revision_f_qf_gdp_uc2_pi)/std(finalc_uc2_pi),2)])
disp(['     End-point - Noise-to-signal ratio of revision QF to F - pi - UC2(GDP,pi):                         ',num2str(std(revision_f_qf_pi_uc2_pi)/std(finalc_uc2_pi),2)])
disp(['  Param. Inst. - Noise-to-signal ratio of revision QRT to QF - UC2(GDP,pi):                 ',num2str(std(revision_qf_qrt_uc2_pi)/std(finalc_uc2_pi),2)])
disp(['     Param. Inst. - Noise-to-signal ratio of revision QRT to QF - GDP - UC2(GDP,pi):                  ',num2str(std(revision_qf_qrt_gdp_uc2_pi)/std(finalc_uc2_pi),2)])
disp(['     Param. Inst. - Noise-to-signal ratio of revision QRT to QF - pi - UC2(GDP,pi):                    ',num2str(std(revision_qf_qrt_pi_uc2_pi)/std(finalc_uc2_pi),2)])
disp(['  Data Revision - Noise-to-signal ratio of revision RT to QRT - UC2(GDP,pi):                ',num2str(std(revision_qrt_rt_uc2_pi)/std(finalc_uc2_pi),2)])
disp(['     Data Revision - Noise-to-signal ratio of revision RT to QRT - GDP - UC2(GDP,pi):                 ',num2str(std(revision_qrt_rt_gdp_uc2_pi)/std(finalc_uc2_pi),2)])
disp(['     Data Revision - Noise-to-signal ratio of revision RT to QRT - pi - UC2(GDP,pi):                   ',num2str(std(revision_qrt_rt_pi_uc2_pi)/std(finalc_uc2_pi),2)])
disp(['  Residual - UC2(GDP,pi):                                                                   ',num2str((std(revision_f_rt_uc2_pi)/std(finalc_uc2_pi)-std(revision_f_qf_uc2_pi)/std(finalc_uc2_pi)- std(revision_qf_qrt_uc2_pi)/std(finalc_uc2_pi)-std(revision_qrt_rt_uc2_pi)/std(finalc_uc2_pi)),2)])
disp('   ')
disp([' Noise-to-signal ratio due to GDP - UC2(GDP,pi):                                            ',num2str(std(revision_f_rt_gdp_uc2_pi)/std(finalc_uc2_pi),2)])
disp([' Noise-to-signal ratio due to pi - UC2(GDP,pi):                                             ',num2str(std(revision_f_rt_pi_uc2_pi)/std(finalc_uc2_pi),2)])
disp([' Residual - UC2(GDP,pi):                                                                    ',num2str((std(revision_f_rt_uc2_pi)/std(finalc_uc2_pi)-std(revision_f_rt_gdp_uc2_pi)/std(finalc_uc2_pi)- std(revision_f_rt_pi_uc2_pi)/std(finalc_uc2_pi)),2)])
disp('   ')
disp('   ')
    
disp('   ')
disp('   ')
disp('UC3   ')
disp('   ')
disp(['Noise-to-signal ratio - UC3:                                ',num2str(std(revision_f_rt_uc3)/std(finalc_uc3),2)])
disp('   ')
disp(['  End-point - Noise-to-signal ratio of revision QF to F - UC3:                      ',num2str(std(revision_f_qf_uc3)/std(finalc_uc3),2)])
disp(['     End-point - Noise-to-signal ratio of revision QF to F - GDP - UC3:                       ',num2str(std(revision_f_qf_gdp_uc3)/std(finalc_uc3),2)])
disp(['     End-point - Noise-to-signal ratio of revision QF to F - u - UC3:                         ',num2str(std(revision_f_qf_u_uc3)/std(finalc_uc3),2)])
disp(['     End-point - Noise-to-signal ratio of revision QF to F - pi - UC3:                        ',num2str(std(revision_f_qf_pi_uc3)/std(finalc_uc3),2)])
disp(['  Param. Inst. - Noise-to-signal ratio of revision QRT to QF - UC3:                 ',num2str(std(revision_qf_qrt_uc3)/std(finalc_uc3),2)])
disp(['     Param. Inst. - Noise-to-signal ratio of revision QRT to QF - GDP - UC3:                  ',num2str(std(revision_qf_qrt_gdp_uc3)/std(finalc_uc3),2)])
disp(['     Param. Inst. - Noise-to-signal ratio of revision QRT to QF - u - UC3:                    ',num2str(std(revision_qf_qrt_u_uc3)/std(finalc_uc3),2)])
disp(['     Param. Inst. - Noise-to-signal ratio of revision QRT to QF - pi - UC3:                   ',num2str(std(revision_qf_qrt_pi_uc3)/std(finalc_uc3),2)])
disp(['  Data Revision - Noise-to-signal ratio of revision RT to QRT - UC3:                ',num2str(std(revision_qrt_rt_uc3)/std(finalc_uc3),2)])
disp(['     Data Revision - Noise-to-signal ratio of revision RT to QRT - GDP - UC3:                 ',num2str(std(revision_qrt_rt_gdp_uc3)/std(finalc_uc3),2)])
disp(['     Data Revision - Noise-to-signal ratio of revision RT to QRT - u - UC3:                   ',num2str(std(revision_qrt_rt_u_uc3)/std(finalc_uc3),2)])
disp(['     Data Revision - Noise-to-signal ratio of revision RT to QRT - pi - UC3:                  ',num2str(std(revision_qrt_rt_pi_uc3)/std(finalc_uc3),2)])
disp(['  Residual - UC3:                                                                   ',num2str((std(revision_f_rt_uc3)/std(finalc_uc3)-std(revision_f_qf_uc3)/std(finalc_uc3)- std(revision_qf_qrt_uc3)/std(finalc_uc3)-std(revision_qrt_rt_uc3)/std(finalc_uc3)),2)])
disp('   ')
disp([' Noise-to-signal ratio due to GDP - UC3:                                            ',num2str(std(revision_f_rt_gdp_uc3)/std(finalc_uc3),2)])
disp([' Noise-to-signal ratio due to u - UC3:                                              ',num2str(std(revision_f_rt_u_uc3)/std(finalc_uc3),2)])
disp([' Noise-to-signal ratio due to pi - UC3:                                             ',num2str(std(revision_f_rt_pi_uc3)/std(finalc_uc3),2)])
disp([' Residual - UC3:                                                                    ',num2str((std(revision_f_rt_uc3)/std(finalc_uc3)-std(revision_f_rt_gdp_uc3)/std(finalc_uc3)- std(revision_f_rt_u_uc3)/std(finalc_uc3)- std(revision_f_rt_pi_uc3)/std(finalc_uc3)),2)])
disp('   ')
disp('   ')

end

if covariances_show == 1


diary('covariances_10112022.txt')


    disp('   ')
    disp('   ')
    disp('UC1   ')
    disp('   ')
    a = [revision_f_qf_uc1  revision_qf_qrt_uc1 revision_qrt_rt_uc1];
    b = cov(a);
disp(['  Cov End-point and Param. Inst.:                        ',num2str(2*b(1,2),2)])
disp(['  Cov End-point and Data Revision:                       ',num2str(2*b(1,3),2)])
disp(['  Cov Param. Inst. and Data Revision:                    ',num2str(2*b(2,3),2)])
disp(['  Residual - UC1(GDP):                                   ',num2str((std(revision_f_rt_uc1)/std(finalc_uc1)-std(revision_f_qf_uc1)/std(finalc_uc1)- std(revision_qf_qrt_uc1)/std(finalc_uc1)-std(revision_qrt_rt_uc1)/std(finalc_uc1)),2)])
    
disp('   ')
disp('   ')
disp('HP   ')
disp('   ')
    a = [revision_f_qf_hp  revision_qf_qrt_hp revision_qrt_rt_hp];
    b = cov(a);
disp(['  Cov End-point and Param. Inst.:                        ',num2str(2*b(1,2),2)])
disp(['  Cov End-point and Data Revision:                       ',num2str(2*b(1,3),2)])
disp(['  Cov Param. Inst. and Data Revision:                    ',num2str(2*b(2,3),2)])
disp(['  Residual - HP(GDP):                                    ',num2str((std(revision_f_rt_hp)/std(finalc_hp)-std(revision_f_qf_hp)/std(finalc_hp)- std(revision_qf_qrt_hp)/std(finalc_hp)-std(revision_qrt_rt_hp)/std(finalc_hp)),2)])

disp('   ')
disp('   ')
disp('HP Garratt   ')
disp('   ')
    a = [revision_f_qf_hp_gar  revision_qf_qrt_hp_gar revision_qrt_rt_hp_gar];
    b = cov(a);
disp(['  Cov End-point and Param. Inst.:                        ',num2str(2*b(1,2),2)])
disp(['  Cov End-point and Data Revision:                       ',num2str(2*b(1,3),2)])
disp(['  Cov Param. Inst. and Data Revision:                    ',num2str(2*b(2,3),2)])
disp(['  Residual - HP Garratt(GDP):                            ',num2str((std(revision_f_rt_hp_gar)/std(finalc_hp_gar)-std(revision_f_qf_hp_gar)/std(finalc_hp_gar)- std(revision_qf_qrt_hp_gar)/std(finalc_hp_gar)-std(revision_qrt_rt_hp_gar)/std(finalc_hp_gar)),2)])

disp('   ')
disp('   ')
disp('UC2 - Unemployment   ')
disp('   ')
    a = [revision_f_qf_uc2  revision_qf_qrt_uc2 revision_qrt_rt_uc2];
    b = cov(a);
disp(['  Cov End-point and Param. Inst.:                        ',num2str(2*b(1,2),2)])
disp(['  Cov End-point and Data Revision:                       ',num2str(2*b(1,3),2)])
disp(['  Cov Param. Inst. and Data Revision:                    ',num2str(2*b(2,3),2)])
disp(['  Residual - UC2(GDP,u):                                 ',num2str((std(revision_f_rt_uc2)/std(finalc_uc2)-std(revision_f_qf_uc2)/std(finalc_uc2)- std(revision_qf_qrt_uc2)/std(finalc_uc2)-std(revision_qrt_rt_uc2)/std(finalc_uc2)),2)])

disp('   ')
disp('   ')
disp('UC2 - Capacity Utilization   ')
disp('   ')
    a = [revision_f_qf_uc2_cu  revision_qf_qrt_uc2_cu revision_qrt_rt_uc2_cu];
    b = cov(a);
disp(['  Cov End-point and Param. Inst.:                        ',num2str(2*b(1,2),2)])
disp(['  Cov End-point and Data Revision:                       ',num2str(2*b(1,3),2)])
disp(['  Cov Param. Inst. and Data Revision:                    ',num2str(2*b(2,3),2)])
disp(['  Residual - UC2(GDP,cu):                                ',num2str((std(revision_f_rt_uc2_cu)/std(finalc_uc2_cu)-std(revision_f_qf_uc2_cu)/std(finalc_uc2_cu)- std(revision_qf_qrt_uc2_cu)/std(finalc_uc2_cu)-std(revision_qrt_rt_uc2_cu)/std(finalc_uc2_cu)),2)])
    

disp('   ')
disp('   ')
disp('UC2 - Inflation   ')
disp('   ')
    a = [revision_f_qf_uc2_pi  revision_qf_qrt_uc2_pi revision_qrt_rt_uc2_pi];
    b = cov(a);
disp(['  Cov End-point and Param. Inst.:                        ',num2str(2*b(1,2),2)])
disp(['  Cov End-point and Data Revision:                       ',num2str(2*b(1,3),2)])
disp(['  Cov Param. Inst. and Data Revision:                    ',num2str(2*b(2,3),2)])
disp(['  Residual - UC2(GDP,pi):                                ',num2str((std(revision_f_rt_uc2_pi)/std(finalc_uc2_pi)-std(revision_f_qf_uc2_pi)/std(finalc_uc2_pi)- std(revision_qf_qrt_uc2_pi)/std(finalc_uc2_pi)-std(revision_qrt_rt_uc2_pi)/std(finalc_uc2_pi)),2)])
    
disp('   ')
disp('   ')
disp('UC3   ')
disp('   ')
    a = [revision_f_qf_uc3  revision_qf_qrt_uc3 revision_qrt_rt_uc3];
    b = cov(a);
disp(['  Cov End-point and Param. Inst.:                        ',num2str(2*b(1,2),2)])
disp(['  Cov End-point and Data Revision:                       ',num2str(2*b(1,3),2)])
disp(['  Cov Param. Inst. and Data Revision:                    ',num2str(2*b(2,3),2)])  
disp(['  Residual - UC3:                                ',num2str((std(revision_f_rt_uc3)/std(finalc_uc3)-std(revision_f_qf_uc3)/std(finalc_uc3)- std(revision_qf_qrt_uc3)/std(finalc_uc3)-std(revision_qrt_rt_uc3)/std(finalc_uc3)),2)])
disp(['  Rel Cov End-point and Param. Inst.:                        ',num2str(2*b(1,2)/var(finalc_uc3),2)])
disp(['  Rel Cov End-point and Data Revision:                       ',num2str(2*b(1,3)/var(finalc_uc3),2)])
disp(['  Rel Cov Param. Inst. and Data Revision:                    ',num2str(2*b(2,3)/var(finalc_uc3),2)])  
disp(['  Sum of Rel Cov UC3:                    ',num2str(2*b(1,2)/var(finalc_uc3)+2*b(1,3)/var(finalc_uc3)+2*b(2,3)/var(finalc_uc3),2)])
disp(['  Rel Residual - UC3:                                ',num2str(var(revision_f_rt_uc3)/var(finalc_uc3)-var(revision_f_qf_uc3)/var(finalc_uc3)- var(revision_qf_qrt_uc3)/var(finalc_uc3)-var(revision_qrt_rt_uc3)/var(finalc_uc3),2)])
        

end